import { defineComponent as Et, ref as ke, onMounted as ma, onUnmounted as ya, computed as dr, watch as St, toRefs as ga, openBlock as Ot, createElementBlock as Mt, createElementVNode as Ke, normalizeClass as wa, withDirectives as ba, vShow as Ca, renderSlot as Cr, withModifiers as et } from "vue";
var _r = (n, i, a) => {
  if (!i.has(n))
    throw TypeError("Cannot " + a);
}, _a = (n, i, a) => (_r(n, i, "read from private field"), a ? a.call(n) : i.get(n)), $a = (n, i, a) => {
  if (i.has(n))
    throw TypeError("Cannot add the same private member more than once");
  i instanceof WeakSet ? i.add(n) : i.set(n, a);
}, Sa = (n, i, a, u) => (_r(n, i, "write to private field"), u ? u.call(n, a) : i.set(n, a), a);
const pr = [
  "aztec",
  "code_128",
  "code_39",
  "code_93",
  "codabar",
  "data_matrix",
  "ean_13",
  "ean_8",
  "itf",
  "pdf417",
  "qr_code",
  "upc_a",
  "upc_e",
  "unknown"
];
function Pa(n) {
  if ($r(n))
    return {
      width: n.naturalWidth,
      height: n.naturalHeight
    };
  if (Sr(n))
    return {
      width: n.width.baseVal.value,
      height: n.height.baseVal.value
    };
  if (Pr(n))
    return {
      width: n.videoWidth,
      height: n.videoHeight
    };
  if (Ta(n))
    return {
      width: n.width,
      height: n.height
    };
  if (Tr(n))
    return {
      width: n.width,
      height: n.height
    };
  if (Ea(n))
    return {
      width: n.width,
      height: n.height
    };
  if (Er(n))
    return {
      width: n.displayWidth,
      height: n.displayHeight
    };
  throw new TypeError(
    "The provided value is not of type '(Blob or HTMLCanvasElement or HTMLImageElement or HTMLVideoElement or ImageBitmap or ImageData or OffscreenCanvas or SVGImageElement or VideoFrame)'."
  );
}
function $r(n) {
  try {
    return n instanceof HTMLImageElement;
  } catch (i) {
    return !1;
  }
}
function Sr(n) {
  try {
    return n instanceof SVGImageElement;
  } catch (i) {
    return !1;
  }
}
function Pr(n) {
  try {
    return n instanceof HTMLVideoElement;
  } catch (i) {
    return !1;
  }
}
function Ta(n) {
  try {
    return n instanceof HTMLCanvasElement;
  } catch (i) {
    return !1;
  }
}
function Tr(n) {
  try {
    return n instanceof ImageBitmap;
  } catch (i) {
    return !1;
  }
}
function Ea(n) {
  try {
    return n instanceof OffscreenCanvas;
  } catch (i) {
    return !1;
  }
}
function Er(n) {
  try {
    return n instanceof VideoFrame;
  } catch (i) {
    return !1;
  }
}
function Oa(n) {
  try {
    return n instanceof Blob;
  } catch (i) {
    return !1;
  }
}
function Ma(n) {
  try {
    return n instanceof ImageData;
  } catch (i) {
    return !1;
  }
}
function Aa(n, i) {
  try {
    const a = new OffscreenCanvas(n, i);
    if (a.getContext("2d") instanceof OffscreenCanvasRenderingContext2D)
      return a;
    throw void 0;
  } catch (a) {
    const u = document.createElement("canvas");
    return u.width = n, u.height = i, u;
  }
}
async function Or(n) {
  if ($r(n) && !await Ra(n))
    throw new DOMException(
      "Failed to load or decode HTMLImageElement.",
      "InvalidStateError"
    );
  if (Sr(n) && !await ka(n))
    throw new DOMException(
      "Failed to load or decode SVGImageElement.",
      "InvalidStateError"
    );
  if (Er(n) && Fa(n))
    throw new DOMException("VideoFrame is closed.", "InvalidStateError");
  if (Pr(n) && (n.readyState === 0 || n.readyState === 1))
    throw new DOMException("Invalid element or state.", "InvalidStateError");
  if (Tr(n) && Ua(n))
    throw new DOMException(
      "The image source is detached.",
      "InvalidStateError"
    );
  const { width: i, height: a } = Pa(n);
  if (i === 0 || a === 0)
    return null;
  const u = Aa(i, a).getContext("2d");
  u.drawImage(n, 0, 0);
  try {
    return u.getImageData(0, 0, i, a);
  } catch (d) {
    throw new DOMException("Source would taint origin.", "SecurityError");
  }
}
async function Da(n) {
  let i;
  try {
    i = await createImageBitmap(n);
  } catch (a) {
    throw new DOMException(
      "Failed to load or decode Blob.",
      "InvalidStateError"
    );
  }
  return await Or(i);
}
async function xa(n) {
  if (Oa(n))
    return await Da(n);
  if (Ma(n)) {
    if (Ia(n))
      throw new DOMException(
        "The image data has been detached.",
        "InvalidStateError"
      );
    return n;
  }
  return await Or(n);
}
async function Ra(n) {
  try {
    return await n.decode(), !0;
  } catch (i) {
    return !1;
  }
}
async function ka(n) {
  var i;
  try {
    return await ((i = n.decode) == null ? void 0 : i.call(n)), !0;
  } catch (a) {
    return !1;
  }
}
function Fa(n) {
  return n.format === null;
}
function Ia(n) {
  return n.data.buffer.byteLength === 0;
}
function Ua(n) {
  return n.width === 0 && n.height === 0;
}
function hr(n, i) {
  return n instanceof DOMException ? new DOMException(`${i}: ${n.message}`, n.name) : n instanceof Error ? new n.constructor(`${i}: ${n.message}`) : new Error(`${i}: ${n}`);
}
const vr = (n) => {
  let i;
  const a = /* @__PURE__ */ new Set(), u = (v, w) => {
    const C = typeof v == "function" ? v(i) : v;
    if (!Object.is(C, i)) {
      const y = i;
      i = w ?? typeof C != "object" ? C : Object.assign({}, i, C), a.forEach((_) => _(i, y));
    }
  }, d = () => i, h = { setState: u, getState: d, subscribe: (v) => (a.add(v), () => a.delete(v)), destroy: () => {
    a.clear();
  } };
  return i = n(u, d, h), h;
}, ja = (n) => n ? vr(n) : vr, Wa = {
  locateFile: (n, i) => {
    var a;
    const u = (a = n.match(/_(.+?)\.wasm$/)) == null ? void 0 : a[1];
    return u ? `https://cdn.jsdelivr.net/npm/@sec-ant/zxing-wasm@2.1.3/dist/${u}/${n}` : i + n;
  }
}, Se = ja()(() => ({
  zxingModuleWeakMap: /* @__PURE__ */ new WeakMap(),
  zxingModuleOverrides: Wa
}));
function Vi(n) {
  Se.setState({
    zxingModuleOverrides: n
  });
}
function Mr(n, i = Se.getState().zxingModuleOverrides) {
  const { zxingModuleWeakMap: a } = Se.getState(), u = a.get(
    n
  );
  if (u && Object.is(i, Se.getState().zxingModuleOverrides))
    return u;
  {
    Se.setState({
      zxingModuleOverrides: i
    });
    const d = n(i);
    return a.set(n, d), d;
  }
}
const mr = [
  "Aztec",
  "Codabar",
  "Code128",
  "Code39",
  "Code93",
  "DataBar",
  "DataBarExpanded",
  "DataMatrix",
  "EAN-13",
  "EAN-8",
  "ITF",
  "Linear-Codes",
  "Matrix-Codes",
  "MaxiCode",
  "MicroQRCode",
  "None",
  "PDF417",
  "QRCode",
  "UPC-A",
  "UPC-E"
], de = {
  tryHarder: !0,
  formats: [],
  maxSymbols: 255
};
async function La(n, {
  tryHarder: i = de.tryHarder,
  formats: a = de.formats,
  maxSymbols: u = de.maxSymbols
} = de, d) {
  const h = await Mr(
    d,
    Se.getState().zxingModuleOverrides
  ), {
    data: v,
    width: w,
    height: C,
    data: { byteLength: y }
  } = n, _ = h._malloc(y);
  h.HEAP8.set(v, _);
  const S = h.readBarcodesFromPixmap(
    _,
    w,
    C,
    i,
    Ha(a),
    u
  );
  h._free(_);
  const $ = [];
  for (let A = 0; A < S.size(); ++A) {
    const M = S.get(A);
    $.push({
      ...M,
      format: Va(M.format)
    });
  }
  return $;
}
function Ha(n) {
  return n.join("|");
}
function Va(n) {
  const i = yr(n);
  let a = 0, u = mr.length - 1;
  for (; a <= u; ) {
    const d = Math.floor((a + u) / 2), h = mr[d], v = yr(h);
    if (v === i)
      return h;
    v < i ? a = d + 1 : u = d - 1;
  }
  return "None";
}
function yr(n) {
  return n.toLowerCase().replace(/_-\[\]/g, "");
}
var Ar = (() => {
  var n = import.meta.url;
  return function(i = {}) {
    var a = i, u, d;
    a.ready = new Promise((e, t) => {
      u = e, d = t;
    });
    var h = Object.assign({}, a), v = "./this.program", w = typeof window == "object", C = typeof importScripts == "function";
    typeof process == "object" && typeof process.versions == "object" && process.versions.node;
    var y = "";
    function _(e) {
      return a.locateFile ? a.locateFile(e, y) : y + e;
    }
    var S;
    (w || C) && (C ? y = self.location.href : typeof document < "u" && document.currentScript && (y = document.currentScript.src), n && (y = n), y.indexOf("blob:") !== 0 ? y = y.substr(0, y.replace(/[?#].*/, "").lastIndexOf("/") + 1) : y = "", C && (S = (e) => {
      var t = new XMLHttpRequest();
      return t.open("GET", e, !1), t.responseType = "arraybuffer", t.send(null), new Uint8Array(t.response);
    })), a.print || console.log.bind(console);
    var $ = a.printErr || console.error.bind(console);
    Object.assign(a, h), h = null, a.arguments && a.arguments, a.thisProgram && (v = a.thisProgram), a.quit && a.quit;
    var A;
    a.wasmBinary && (A = a.wasmBinary), a.noExitRuntime, typeof WebAssembly != "object" && Le("no native wasm support detected");
    var M, T, j = !1, U, V, Z, ve, z, H, Fe, Ie;
    function Ue() {
      var e = M.buffer;
      a.HEAP8 = U = new Int8Array(e), a.HEAP16 = Z = new Int16Array(e), a.HEAP32 = z = new Int32Array(e), a.HEAPU8 = V = new Uint8Array(e), a.HEAPU16 = ve = new Uint16Array(e), a.HEAPU32 = H = new Uint32Array(e), a.HEAPF32 = Fe = new Float32Array(e), a.HEAPF64 = Ie = new Float64Array(e);
    }
    var je, Ce = [], Te = [], We = [];
    function it() {
      if (a.preRun)
        for (typeof a.preRun == "function" && (a.preRun = [a.preRun]); a.preRun.length; )
          st(a.preRun.shift());
      ft(Ce);
    }
    function ce() {
      ft(Te);
    }
    function K() {
      if (a.postRun)
        for (typeof a.postRun == "function" && (a.postRun = [a.postRun]); a.postRun.length; )
          ut(a.postRun.shift());
      ft(We);
    }
    function st(e) {
      Ce.unshift(e);
    }
    function ct(e) {
      Te.unshift(e);
    }
    function ut(e) {
      We.unshift(e);
    }
    var te = 0, me = null;
    function lt(e) {
      te++, a.monitorRunDependencies && a.monitorRunDependencies(te);
    }
    function Gr(e) {
      if (te--, a.monitorRunDependencies && a.monitorRunDependencies(te), te == 0 && me) {
        var t = me;
        me = null, t();
      }
    }
    function Le(e) {
      a.onAbort && a.onAbort(e), e = "Aborted(" + e + ")", $(e), j = !0, e += ". Build with -sASSERTIONS for more info.";
      var t = new WebAssembly.RuntimeError(e);
      throw d(t), t;
    }
    var qr = "data:application/octet-stream;base64,";
    function At(e) {
      return e.startsWith(qr);
    }
    var ye;
    a.locateFile ? (ye = "zxing_reader.wasm", At(ye) || (ye = _(ye))) : ye = new URL("/reader/zxing_reader.wasm", self.location).href;
    function Dt(e) {
      if (e == ye && A)
        return new Uint8Array(A);
      if (S)
        return S(e);
      throw "both async and sync fetching of the wasm failed";
    }
    function Nr(e) {
      return !A && (w || C) && typeof fetch == "function" ? fetch(e, { credentials: "same-origin" }).then((t) => {
        if (!t.ok)
          throw "failed to load wasm binary file at '" + e + "'";
        return t.arrayBuffer();
      }).catch(() => Dt(e)) : Promise.resolve().then(() => Dt(e));
    }
    function xt(e, t, r) {
      return Nr(e).then((o) => WebAssembly.instantiate(o, t)).then((o) => o).then(r, (o) => {
        $("failed to asynchronously prepare wasm: " + o), Le(o);
      });
    }
    function Yr(e, t, r, o) {
      return !e && typeof WebAssembly.instantiateStreaming == "function" && !At(t) && typeof fetch == "function" ? fetch(t, { credentials: "same-origin" }).then((s) => {
        var c = WebAssembly.instantiateStreaming(s, r);
        return c.then(o, function(l) {
          return $("wasm streaming compile failed: " + l), $("falling back to ArrayBuffer instantiation"), xt(t, r, o);
        });
      }) : xt(t, r, o);
    }
    function Jr() {
      var e = { a: Uo };
      function t(o, s) {
        var c = o.exports;
        return T = c, M = T.qa, Ue(), je = T.ua, ct(T.ra), Gr(), c;
      }
      lt();
      function r(o) {
        t(o.instance);
      }
      if (a.instantiateWasm)
        try {
          return a.instantiateWasm(e, t);
        } catch (o) {
          $("Module.instantiateWasm callback failed with error: " + o), d(o);
        }
      return Yr(A, ye, e, r).catch(d), {};
    }
    var ft = (e) => {
      for (; e.length > 0; )
        e.shift()(a);
    }, He = [], Ve = 0;
    function Qr(e) {
      var t = new ze(e);
      return t.get_caught() || (t.set_caught(!0), Ve--), t.set_rethrown(!1), He.push(t), ir(t.excPtr), t.get_exception_ptr();
    }
    var re = 0;
    function Xr() {
      D(0, 0);
      var e = He.pop();
      ar(e.excPtr), re = 0;
    }
    function ze(e) {
      this.excPtr = e, this.ptr = e - 24, this.set_type = function(t) {
        H[this.ptr + 4 >> 2] = t;
      }, this.get_type = function() {
        return H[this.ptr + 4 >> 2];
      }, this.set_destructor = function(t) {
        H[this.ptr + 8 >> 2] = t;
      }, this.get_destructor = function() {
        return H[this.ptr + 8 >> 2];
      }, this.set_caught = function(t) {
        t = t ? 1 : 0, U[this.ptr + 12 >> 0] = t;
      }, this.get_caught = function() {
        return U[this.ptr + 12 >> 0] != 0;
      }, this.set_rethrown = function(t) {
        t = t ? 1 : 0, U[this.ptr + 13 >> 0] = t;
      }, this.get_rethrown = function() {
        return U[this.ptr + 13 >> 0] != 0;
      }, this.init = function(t, r) {
        this.set_adjusted_ptr(0), this.set_type(t), this.set_destructor(r);
      }, this.set_adjusted_ptr = function(t) {
        H[this.ptr + 16 >> 2] = t;
      }, this.get_adjusted_ptr = function() {
        return H[this.ptr + 16 >> 2];
      }, this.get_exception_ptr = function() {
        var t = cr(this.get_type());
        if (t)
          return H[this.excPtr >> 2];
        var r = this.get_adjusted_ptr();
        return r !== 0 ? r : this.excPtr;
      };
    }
    function Zr(e) {
      throw re || (re = e), re;
    }
    var dt = (e) => {
      var t = re;
      if (!t)
        return Re(0), 0;
      var r = new ze(t);
      r.set_adjusted_ptr(t);
      var o = r.get_type();
      if (!o)
        return Re(0), t;
      for (var s in e) {
        var c = e[s];
        if (c === 0 || c === o)
          break;
        var l = r.ptr + 16;
        if (sr(c, o, l))
          return Re(c), t;
      }
      return Re(o), t;
    }, Kr = () => dt([]), en = (e) => dt([e]), tn = (e, t) => dt([e, t]);
    function rn(e) {
      var t = new ze(e).get_exception_ptr();
      return t;
    }
    function nn() {
      var e = He.pop();
      e || Le("no exception to throw");
      var t = e.excPtr;
      throw e.get_rethrown() || (He.push(e), e.set_rethrown(!0), e.set_caught(!1), Ve++), re = t, re;
    }
    function on(e, t, r) {
      var o = new ze(e);
      throw o.init(t, r), re = e, Ve++, re;
    }
    function an() {
      return Ve;
    }
    var Be = {};
    function Rt(e) {
      for (; e.length; ) {
        var t = e.pop(), r = e.pop();
        r(t);
      }
    }
    function Ee(e) {
      return this.fromWireType(z[e >> 2]);
    }
    var _e = {}, ge = {}, Ge = {}, kt = void 0;
    function qe(e) {
      throw new kt(e);
    }
    function we(e, t, r) {
      e.forEach(function(f) {
        Ge[f] = t;
      });
      function o(f) {
        var p = r(f);
        p.length !== e.length && qe("Mismatched type converter count");
        for (var m = 0; m < e.length; ++m)
          ne(e[m], p[m]);
      }
      var s = new Array(t.length), c = [], l = 0;
      t.forEach((f, p) => {
        ge.hasOwnProperty(f) ? s[p] = ge[f] : (c.push(f), _e.hasOwnProperty(f) || (_e[f] = []), _e[f].push(() => {
          s[p] = ge[f], ++l, l === c.length && o(s);
        }));
      }), c.length === 0 && o(s);
    }
    var sn = function(e) {
      var t = Be[e];
      delete Be[e];
      var r = t.rawConstructor, o = t.rawDestructor, s = t.fields, c = s.map((l) => l.getterReturnType).concat(s.map((l) => l.setterArgumentType));
      we([e], c, (l) => {
        var f = {};
        return s.forEach((p, m) => {
          var b = p.fieldName, E = l[m], O = p.getter, k = p.getterContext, W = l[m + s.length], q = p.setter, L = p.setterContext;
          f[b] = { read: (N) => E.fromWireType(O(k, N)), write: (N, g) => {
            var P = [];
            q(L, N, W.toWireType(P, g)), Rt(P);
          } };
        }), [{ name: t.name, fromWireType: function(p) {
          var m = {};
          for (var b in f)
            m[b] = f[b].read(p);
          return o(p), m;
        }, toWireType: function(p, m) {
          for (var b in f)
            if (!(b in m))
              throw new TypeError(`Missing field: "${b}"`);
          var E = r();
          for (b in f)
            f[b].write(E, m[b]);
          return p !== null && p.push(o, E), E;
        }, argPackAdvance: 8, readValueFromPointer: Ee, destructorFunction: o }];
      });
    };
    function cn(e, t, r, o, s) {
    }
    function pt(e) {
      switch (e) {
        case 1:
          return 0;
        case 2:
          return 1;
        case 4:
          return 2;
        case 8:
          return 3;
        default:
          throw new TypeError(`Unknown type size: ${e}`);
      }
    }
    function un() {
      for (var e = new Array(256), t = 0; t < 256; ++t)
        e[t] = String.fromCharCode(t);
      Ft = e;
    }
    var Ft = void 0;
    function Y(e) {
      for (var t = "", r = e; V[r]; )
        t += Ft[V[r++]];
      return t;
    }
    var $e = void 0;
    function F(e) {
      throw new $e(e);
    }
    function ln(e, t, r = {}) {
      var o = t.name;
      if (e || F(`type "${o}" must have a positive integer typeid pointer`), ge.hasOwnProperty(e)) {
        if (r.ignoreDuplicateRegistrations)
          return;
        F(`Cannot register type '${o}' twice`);
      }
      if (ge[e] = t, delete Ge[e], _e.hasOwnProperty(e)) {
        var s = _e[e];
        delete _e[e], s.forEach((c) => c());
      }
    }
    function ne(e, t, r = {}) {
      if (!("argPackAdvance" in t))
        throw new TypeError("registerType registeredInstance requires argPackAdvance");
      return ln(e, t, r);
    }
    function fn(e, t, r, o, s) {
      var c = pt(r);
      t = Y(t), ne(e, { name: t, fromWireType: function(l) {
        return !!l;
      }, toWireType: function(l, f) {
        return f ? o : s;
      }, argPackAdvance: 8, readValueFromPointer: function(l) {
        var f;
        if (r === 1)
          f = U;
        else if (r === 2)
          f = Z;
        else if (r === 4)
          f = z;
        else
          throw new TypeError("Unknown boolean type size: " + t);
        return this.fromWireType(f[l >> c]);
      }, destructorFunction: null });
    }
    function dn(e) {
      if (!(this instanceof ue) || !(e instanceof ue))
        return !1;
      for (var t = this.$$.ptrType.registeredClass, r = this.$$.ptr, o = e.$$.ptrType.registeredClass, s = e.$$.ptr; t.baseClass; )
        r = t.upcast(r), t = t.baseClass;
      for (; o.baseClass; )
        s = o.upcast(s), o = o.baseClass;
      return t === o && r === s;
    }
    function pn(e) {
      return { count: e.count, deleteScheduled: e.deleteScheduled, preservePointerOnDelete: e.preservePointerOnDelete, ptr: e.ptr, ptrType: e.ptrType, smartPtr: e.smartPtr, smartPtrType: e.smartPtrType };
    }
    function ht(e) {
      function t(r) {
        return r.$$.ptrType.registeredClass.name;
      }
      F(t(e) + " instance already deleted");
    }
    var vt = !1;
    function It(e) {
    }
    function hn(e) {
      e.smartPtr ? e.smartPtrType.rawDestructor(e.smartPtr) : e.ptrType.registeredClass.rawDestructor(e.ptr);
    }
    function Ut(e) {
      e.count.value -= 1;
      var t = e.count.value === 0;
      t && hn(e);
    }
    function jt(e, t, r) {
      if (t === r)
        return e;
      if (r.baseClass === void 0)
        return null;
      var o = jt(e, t, r.baseClass);
      return o === null ? null : r.downcast(o);
    }
    var Wt = {};
    function vn() {
      return Object.keys(Ae).length;
    }
    function mn() {
      var e = [];
      for (var t in Ae)
        Ae.hasOwnProperty(t) && e.push(Ae[t]);
      return e;
    }
    var Oe = [];
    function mt() {
      for (; Oe.length; ) {
        var e = Oe.pop();
        e.$$.deleteScheduled = !1, e.delete();
      }
    }
    var Me = void 0;
    function yn(e) {
      Me = e, Oe.length && Me && Me(mt);
    }
    function gn() {
      a.getInheritedInstanceCount = vn, a.getLiveInheritedInstances = mn, a.flushPendingDeletes = mt, a.setDelayFunction = yn;
    }
    var Ae = {};
    function wn(e, t) {
      for (t === void 0 && F("ptr should not be undefined"); e.baseClass; )
        t = e.upcast(t), e = e.baseClass;
      return t;
    }
    function bn(e, t) {
      return t = wn(e, t), Ae[t];
    }
    function Ne(e, t) {
      (!t.ptrType || !t.ptr) && qe("makeClassHandle requires ptr and ptrType");
      var r = !!t.smartPtrType, o = !!t.smartPtr;
      return r !== o && qe("Both smartPtrType and smartPtr must be specified"), t.count = { value: 1 }, De(Object.create(e, { $$: { value: t } }));
    }
    function Cn(e) {
      var t = this.getPointee(e);
      if (!t)
        return this.destructor(e), null;
      var r = bn(this.registeredClass, t);
      if (r !== void 0) {
        if (r.$$.count.value === 0)
          return r.$$.ptr = t, r.$$.smartPtr = e, r.clone();
        var o = r.clone();
        return this.destructor(e), o;
      }
      function s() {
        return this.isSmartPointer ? Ne(this.registeredClass.instancePrototype, { ptrType: this.pointeeType, ptr: t, smartPtrType: this, smartPtr: e }) : Ne(this.registeredClass.instancePrototype, { ptrType: this, ptr: e });
      }
      var c = this.registeredClass.getActualType(t), l = Wt[c];
      if (!l)
        return s.call(this);
      var f;
      this.isConst ? f = l.constPointerType : f = l.pointerType;
      var p = jt(t, this.registeredClass, f.registeredClass);
      return p === null ? s.call(this) : this.isSmartPointer ? Ne(f.registeredClass.instancePrototype, { ptrType: f, ptr: p, smartPtrType: this, smartPtr: e }) : Ne(f.registeredClass.instancePrototype, { ptrType: f, ptr: p });
    }
    var De = function(e) {
      return typeof FinalizationRegistry > "u" ? (De = (t) => t, e) : (vt = new FinalizationRegistry((t) => {
        Ut(t.$$);
      }), De = (t) => {
        var r = t.$$, o = !!r.smartPtr;
        if (o) {
          var s = { $$: r };
          vt.register(t, s, t);
        }
        return t;
      }, It = (t) => vt.unregister(t), De(e));
    };
    function _n() {
      if (this.$$.ptr || ht(this), this.$$.preservePointerOnDelete)
        return this.$$.count.value += 1, this;
      var e = De(Object.create(Object.getPrototypeOf(this), { $$: { value: pn(this.$$) } }));
      return e.$$.count.value += 1, e.$$.deleteScheduled = !1, e;
    }
    function $n() {
      this.$$.ptr || ht(this), this.$$.deleteScheduled && !this.$$.preservePointerOnDelete && F("Object already scheduled for deletion"), It(this), Ut(this.$$), this.$$.preservePointerOnDelete || (this.$$.smartPtr = void 0, this.$$.ptr = void 0);
    }
    function Sn() {
      return !this.$$.ptr;
    }
    function Pn() {
      return this.$$.ptr || ht(this), this.$$.deleteScheduled && !this.$$.preservePointerOnDelete && F("Object already scheduled for deletion"), Oe.push(this), Oe.length === 1 && Me && Me(mt), this.$$.deleteScheduled = !0, this;
    }
    function Tn() {
      ue.prototype.isAliasOf = dn, ue.prototype.clone = _n, ue.prototype.delete = $n, ue.prototype.isDeleted = Sn, ue.prototype.deleteLater = Pn;
    }
    function ue() {
    }
    var En = 48, On = 57;
    function Lt(e) {
      if (e === void 0)
        return "_unknown";
      e = e.replace(/[^a-zA-Z0-9_]/g, "$");
      var t = e.charCodeAt(0);
      return t >= En && t <= On ? `_${e}` : e;
    }
    function Ht(e, t) {
      return e = Lt(e), { [e]: function() {
        return t.apply(this, arguments);
      } }[e];
    }
    function Vt(e, t, r) {
      if (e[t].overloadTable === void 0) {
        var o = e[t];
        e[t] = function() {
          return e[t].overloadTable.hasOwnProperty(arguments.length) || F(`Function '${r}' called with an invalid number of arguments (${arguments.length}) - expects one of (${e[t].overloadTable})!`), e[t].overloadTable[arguments.length].apply(this, arguments);
        }, e[t].overloadTable = [], e[t].overloadTable[o.argCount] = o;
      }
    }
    function zt(e, t, r) {
      a.hasOwnProperty(e) ? ((r === void 0 || a[e].overloadTable !== void 0 && a[e].overloadTable[r] !== void 0) && F(`Cannot register public name '${e}' twice`), Vt(a, e, e), a.hasOwnProperty(r) && F(`Cannot register multiple overloads of a function with the same number of arguments (${r})!`), a[e].overloadTable[r] = t) : (a[e] = t, r !== void 0 && (a[e].numArguments = r));
    }
    function Mn(e, t, r, o, s, c, l, f) {
      this.name = e, this.constructor = t, this.instancePrototype = r, this.rawDestructor = o, this.baseClass = s, this.getActualType = c, this.upcast = l, this.downcast = f, this.pureVirtualFunctions = [];
    }
    function yt(e, t, r) {
      for (; t !== r; )
        t.upcast || F(`Expected null or instance of ${r.name}, got an instance of ${t.name}`), e = t.upcast(e), t = t.baseClass;
      return e;
    }
    function An(e, t) {
      if (t === null)
        return this.isReference && F(`null is not a valid ${this.name}`), 0;
      t.$$ || F(`Cannot pass "${bt(t)}" as a ${this.name}`), t.$$.ptr || F(`Cannot pass deleted object as a pointer of type ${this.name}`);
      var r = t.$$.ptrType.registeredClass, o = yt(t.$$.ptr, r, this.registeredClass);
      return o;
    }
    function Dn(e, t) {
      var r;
      if (t === null)
        return this.isReference && F(`null is not a valid ${this.name}`), this.isSmartPointer ? (r = this.rawConstructor(), e !== null && e.push(this.rawDestructor, r), r) : 0;
      t.$$ || F(`Cannot pass "${bt(t)}" as a ${this.name}`), t.$$.ptr || F(`Cannot pass deleted object as a pointer of type ${this.name}`), !this.isConst && t.$$.ptrType.isConst && F(`Cannot convert argument of type ${t.$$.smartPtrType ? t.$$.smartPtrType.name : t.$$.ptrType.name} to parameter type ${this.name}`);
      var o = t.$$.ptrType.registeredClass;
      if (r = yt(t.$$.ptr, o, this.registeredClass), this.isSmartPointer)
        switch (t.$$.smartPtr === void 0 && F("Passing raw pointer to smart pointer is illegal"), this.sharingPolicy) {
          case 0:
            t.$$.smartPtrType === this ? r = t.$$.smartPtr : F(`Cannot convert argument of type ${t.$$.smartPtrType ? t.$$.smartPtrType.name : t.$$.ptrType.name} to parameter type ${this.name}`);
            break;
          case 1:
            r = t.$$.smartPtr;
            break;
          case 2:
            if (t.$$.smartPtrType === this)
              r = t.$$.smartPtr;
            else {
              var s = t.clone();
              r = this.rawShare(r, le.toHandle(function() {
                s.delete();
              })), e !== null && e.push(this.rawDestructor, r);
            }
            break;
          default:
            F("Unsupporting sharing policy");
        }
      return r;
    }
    function xn(e, t) {
      if (t === null)
        return this.isReference && F(`null is not a valid ${this.name}`), 0;
      t.$$ || F(`Cannot pass "${bt(t)}" as a ${this.name}`), t.$$.ptr || F(`Cannot pass deleted object as a pointer of type ${this.name}`), t.$$.ptrType.isConst && F(`Cannot convert argument of type ${t.$$.ptrType.name} to parameter type ${this.name}`);
      var r = t.$$.ptrType.registeredClass, o = yt(t.$$.ptr, r, this.registeredClass);
      return o;
    }
    function Rn(e) {
      return this.rawGetPointee && (e = this.rawGetPointee(e)), e;
    }
    function kn(e) {
      this.rawDestructor && this.rawDestructor(e);
    }
    function Fn(e) {
      e !== null && e.delete();
    }
    function In() {
      oe.prototype.getPointee = Rn, oe.prototype.destructor = kn, oe.prototype.argPackAdvance = 8, oe.prototype.readValueFromPointer = Ee, oe.prototype.deleteObject = Fn, oe.prototype.fromWireType = Cn;
    }
    function oe(e, t, r, o, s, c, l, f, p, m, b) {
      this.name = e, this.registeredClass = t, this.isReference = r, this.isConst = o, this.isSmartPointer = s, this.pointeeType = c, this.sharingPolicy = l, this.rawGetPointee = f, this.rawConstructor = p, this.rawShare = m, this.rawDestructor = b, !s && t.baseClass === void 0 ? o ? (this.toWireType = An, this.destructorFunction = null) : (this.toWireType = xn, this.destructorFunction = null) : this.toWireType = Dn;
    }
    function Bt(e, t, r) {
      a.hasOwnProperty(e) || qe("Replacing nonexistant public symbol"), a[e].overloadTable !== void 0 && r !== void 0 ? a[e].overloadTable[r] = t : (a[e] = t, a[e].argCount = r);
    }
    var Un = (e, t, r) => {
      var o = a["dynCall_" + e];
      return r && r.length ? o.apply(null, [t].concat(r)) : o.call(null, t);
    }, Ye = [], I = (e) => {
      var t = Ye[e];
      return t || (e >= Ye.length && (Ye.length = e + 1), Ye[e] = t = je.get(e)), t;
    }, jn = (e, t, r) => {
      if (e.includes("j"))
        return Un(e, t, r);
      var o = I(t).apply(null, r);
      return o;
    }, Wn = (e, t) => {
      var r = [];
      return function() {
        return r.length = 0, Object.assign(r, arguments), jn(e, t, r);
      };
    };
    function X(e, t) {
      e = Y(e);
      function r() {
        return e.includes("j") ? Wn(e, t) : I(t);
      }
      var o = r();
      return typeof o != "function" && F(`unknown function pointer with signature ${e}: ${t}`), o;
    }
    function Ln(e, t) {
      var r = Ht(t, function(o) {
        this.name = t, this.message = o;
        var s = new Error(o).stack;
        s !== void 0 && (this.stack = this.toString() + `
` + s.replace(/^Error(:[^\n]*)?\n/, ""));
      });
      return r.prototype = Object.create(e.prototype), r.prototype.constructor = r, r.prototype.toString = function() {
        return this.message === void 0 ? this.name : `${this.name}: ${this.message}`;
      }, r;
    }
    var Gt = void 0;
    function qt(e) {
      var t = or(e), r = Y(t);
      return ae(t), r;
    }
    function Je(e, t) {
      var r = [], o = {};
      function s(c) {
        if (!o[c] && !ge[c]) {
          if (Ge[c]) {
            Ge[c].forEach(s);
            return;
          }
          r.push(c), o[c] = !0;
        }
      }
      throw t.forEach(s), new Gt(`${e}: ` + r.map(qt).join([", "]));
    }
    function Hn(e, t, r, o, s, c, l, f, p, m, b, E, O) {
      b = Y(b), c = X(s, c), f && (f = X(l, f)), m && (m = X(p, m)), O = X(E, O);
      var k = Lt(b);
      zt(k, function() {
        Je(`Cannot construct ${b} due to unbound types`, [o]);
      }), we([e, t, r], o ? [o] : [], function(W) {
        W = W[0];
        var q, L;
        o ? (q = W.registeredClass, L = q.instancePrototype) : L = ue.prototype;
        var N = Ht(k, function() {
          if (Object.getPrototypeOf(this) !== g)
            throw new $e("Use 'new' to construct " + b);
          if (P.constructor_body === void 0)
            throw new $e(b + " has no accessible constructor");
          var Ze = P.constructor_body[arguments.length];
          if (Ze === void 0)
            throw new $e(`Tried to invoke ctor of ${b} with invalid number of parameters (${arguments.length}) - expected (${Object.keys(P.constructor_body).toString()}) parameters instead!`);
          return Ze.apply(this, arguments);
        }), g = Object.create(L, { constructor: { value: N } });
        N.prototype = g;
        var P = new Mn(b, N, g, O, q, c, f, m);
        P.baseClass && (P.baseClass.__derivedClasses === void 0 && (P.baseClass.__derivedClasses = []), P.baseClass.__derivedClasses.push(P));
        var B = new oe(b, P, !0, !1, !1), G = new oe(b + "*", P, !1, !1, !1), be = new oe(b + " const*", P, !1, !0, !1);
        return Wt[e] = { pointerType: G, constPointerType: be }, Bt(k, N), [B, G, be];
      });
    }
    function gt(e, t) {
      for (var r = [], o = 0; o < e; o++)
        r.push(H[t + o * 4 >> 2]);
      return r;
    }
    function wt(e, t, r, o, s, c) {
      var l = t.length;
      l < 2 && F("argTypes array size mismatch! Must at least get return value and 'this' types!");
      for (var f = t[1] !== null && r !== null, p = !1, m = 1; m < t.length; ++m)
        if (t[m] !== null && t[m].destructorFunction === void 0) {
          p = !0;
          break;
        }
      var b = t[0].name !== "void", E = l - 2, O = new Array(E), k = [], W = [];
      return function() {
        arguments.length !== E && F(`function ${e} called with ${arguments.length} arguments, expected ${E} args!`), W.length = 0;
        var q;
        k.length = f ? 2 : 1, k[0] = s, f && (q = t[1].toWireType(W, this), k[1] = q);
        for (var L = 0; L < E; ++L)
          O[L] = t[L + 2].toWireType(W, arguments[L]), k.push(O[L]);
        var N = o.apply(null, k);
        function g(P) {
          if (p)
            Rt(W);
          else
            for (var B = f ? 1 : 2; B < t.length; B++) {
              var G = B === 1 ? q : O[B - 2];
              t[B].destructorFunction !== null && t[B].destructorFunction(G);
            }
          if (b)
            return t[0].fromWireType(P);
        }
        return g(N);
      };
    }
    function Vn(e, t, r, o, s, c) {
      var l = gt(t, r);
      s = X(o, s), we([], [e], function(f) {
        f = f[0];
        var p = `constructor ${f.name}`;
        if (f.registeredClass.constructor_body === void 0 && (f.registeredClass.constructor_body = []), f.registeredClass.constructor_body[t - 1] !== void 0)
          throw new $e(`Cannot register multiple constructors with identical number of parameters (${t - 1}) for class '${f.name}'! Overload resolution is currently only performed using the parameter count, not actual type info!`);
        return f.registeredClass.constructor_body[t - 1] = () => {
          Je(`Cannot construct ${f.name} due to unbound types`, l);
        }, we([], l, function(m) {
          return m.splice(1, 0, null), f.registeredClass.constructor_body[t - 1] = wt(p, m, null, s, c), [];
        }), [];
      });
    }
    function zn(e, t, r, o, s, c, l, f, p) {
      var m = gt(r, o);
      t = Y(t), c = X(s, c), we([], [e], function(b) {
        b = b[0];
        var E = `${b.name}.${t}`;
        t.startsWith("@@") && (t = Symbol[t.substring(2)]), f && b.registeredClass.pureVirtualFunctions.push(t);
        function O() {
          Je(`Cannot call ${E} due to unbound types`, m);
        }
        var k = b.registeredClass.instancePrototype, W = k[t];
        return W === void 0 || W.overloadTable === void 0 && W.className !== b.name && W.argCount === r - 2 ? (O.argCount = r - 2, O.className = b.name, k[t] = O) : (Vt(k, t, E), k[t].overloadTable[r - 2] = O), we([], m, function(q) {
          var L = wt(E, q, b, c, l);
          return k[t].overloadTable === void 0 ? (L.argCount = r - 2, k[t] = L) : k[t].overloadTable[r - 2] = L, [];
        }), [];
      });
    }
    function Bn() {
      Object.assign(Nt.prototype, { get(e) {
        return this.allocated[e];
      }, has(e) {
        return this.allocated[e] !== void 0;
      }, allocate(e) {
        var t = this.freelist.pop() || this.allocated.length;
        return this.allocated[t] = e, t;
      }, free(e) {
        this.allocated[e] = void 0, this.freelist.push(e);
      } });
    }
    function Nt() {
      this.allocated = [void 0], this.freelist = [];
    }
    var Q = new Nt();
    function Yt(e) {
      e >= Q.reserved && --Q.get(e).refcount === 0 && Q.free(e);
    }
    function Gn() {
      for (var e = 0, t = Q.reserved; t < Q.allocated.length; ++t)
        Q.allocated[t] !== void 0 && ++e;
      return e;
    }
    function qn() {
      Q.allocated.push({ value: void 0 }, { value: null }, { value: !0 }, { value: !1 }), Q.reserved = Q.allocated.length, a.count_emval_handles = Gn;
    }
    var le = { toValue: (e) => (e || F("Cannot use deleted val. handle = " + e), Q.get(e).value), toHandle: (e) => {
      switch (e) {
        case void 0:
          return 1;
        case null:
          return 2;
        case !0:
          return 3;
        case !1:
          return 4;
        default:
          return Q.allocate({ refcount: 1, value: e });
      }
    } };
    function Nn(e, t) {
      t = Y(t), ne(e, { name: t, fromWireType: function(r) {
        var o = le.toValue(r);
        return Yt(r), o;
      }, toWireType: function(r, o) {
        return le.toHandle(o);
      }, argPackAdvance: 8, readValueFromPointer: Ee, destructorFunction: null });
    }
    function bt(e) {
      if (e === null)
        return "null";
      var t = typeof e;
      return t === "object" || t === "array" || t === "function" ? e.toString() : "" + e;
    }
    function Yn(e, t) {
      switch (t) {
        case 2:
          return function(r) {
            return this.fromWireType(Fe[r >> 2]);
          };
        case 3:
          return function(r) {
            return this.fromWireType(Ie[r >> 3]);
          };
        default:
          throw new TypeError("Unknown float type: " + e);
      }
    }
    function Jn(e, t, r) {
      var o = pt(r);
      t = Y(t), ne(e, { name: t, fromWireType: function(s) {
        return s;
      }, toWireType: function(s, c) {
        return c;
      }, argPackAdvance: 8, readValueFromPointer: Yn(t, o), destructorFunction: null });
    }
    function Qn(e, t, r, o, s, c, l) {
      var f = gt(t, r);
      e = Y(e), s = X(o, s), zt(e, function() {
        Je(`Cannot call ${e} due to unbound types`, f);
      }, t - 1), we([], f, function(p) {
        var m = [p[0], null].concat(p.slice(1));
        return Bt(e, wt(e, m, null, s, c), t - 1), [];
      });
    }
    function Xn(e, t, r) {
      switch (t) {
        case 0:
          return r ? function(o) {
            return U[o];
          } : function(o) {
            return V[o];
          };
        case 1:
          return r ? function(o) {
            return Z[o >> 1];
          } : function(o) {
            return ve[o >> 1];
          };
        case 2:
          return r ? function(o) {
            return z[o >> 2];
          } : function(o) {
            return H[o >> 2];
          };
        default:
          throw new TypeError("Unknown integer type: " + e);
      }
    }
    function Zn(e, t, r, o, s) {
      t = Y(t);
      var c = pt(r), l = (E) => E;
      if (o === 0) {
        var f = 32 - 8 * r;
        l = (E) => E << f >>> f;
      }
      var p = t.includes("unsigned"), m = (E, O) => {
      }, b;
      p ? b = function(E, O) {
        return m(O, this.name), O >>> 0;
      } : b = function(E, O) {
        return m(O, this.name), O;
      }, ne(e, { name: t, fromWireType: l, toWireType: b, argPackAdvance: 8, readValueFromPointer: Xn(t, c, o !== 0), destructorFunction: null });
    }
    function Kn(e, t, r) {
      var o = [Int8Array, Uint8Array, Int16Array, Uint16Array, Int32Array, Uint32Array, Float32Array, Float64Array], s = o[t];
      function c(l) {
        l = l >> 2;
        var f = H, p = f[l], m = f[l + 1];
        return new s(f.buffer, m, p);
      }
      r = Y(r), ne(e, { name: r, fromWireType: c, argPackAdvance: 8, readValueFromPointer: c }, { ignoreDuplicateRegistrations: !0 });
    }
    var Jt = (e, t, r, o) => {
      if (!(o > 0))
        return 0;
      for (var s = r, c = r + o - 1, l = 0; l < e.length; ++l) {
        var f = e.charCodeAt(l);
        if (f >= 55296 && f <= 57343) {
          var p = e.charCodeAt(++l);
          f = 65536 + ((f & 1023) << 10) | p & 1023;
        }
        if (f <= 127) {
          if (r >= c)
            break;
          t[r++] = f;
        } else if (f <= 2047) {
          if (r + 1 >= c)
            break;
          t[r++] = 192 | f >> 6, t[r++] = 128 | f & 63;
        } else if (f <= 65535) {
          if (r + 2 >= c)
            break;
          t[r++] = 224 | f >> 12, t[r++] = 128 | f >> 6 & 63, t[r++] = 128 | f & 63;
        } else {
          if (r + 3 >= c)
            break;
          t[r++] = 240 | f >> 18, t[r++] = 128 | f >> 12 & 63, t[r++] = 128 | f >> 6 & 63, t[r++] = 128 | f & 63;
        }
      }
      return t[r] = 0, r - s;
    }, eo = (e, t, r) => Jt(e, V, t, r), Qt = (e) => {
      for (var t = 0, r = 0; r < e.length; ++r) {
        var o = e.charCodeAt(r);
        o <= 127 ? t++ : o <= 2047 ? t += 2 : o >= 55296 && o <= 57343 ? (t += 4, ++r) : t += 3;
      }
      return t;
    }, Xt = typeof TextDecoder < "u" ? new TextDecoder("utf8") : void 0, to = (e, t, r) => {
      for (var o = t + r, s = t; e[s] && !(s >= o); )
        ++s;
      if (s - t > 16 && e.buffer && Xt)
        return Xt.decode(e.subarray(t, s));
      for (var c = ""; t < s; ) {
        var l = e[t++];
        if (!(l & 128)) {
          c += String.fromCharCode(l);
          continue;
        }
        var f = e[t++] & 63;
        if ((l & 224) == 192) {
          c += String.fromCharCode((l & 31) << 6 | f);
          continue;
        }
        var p = e[t++] & 63;
        if ((l & 240) == 224 ? l = (l & 15) << 12 | f << 6 | p : l = (l & 7) << 18 | f << 12 | p << 6 | e[t++] & 63, l < 65536)
          c += String.fromCharCode(l);
        else {
          var m = l - 65536;
          c += String.fromCharCode(55296 | m >> 10, 56320 | m & 1023);
        }
      }
      return c;
    }, Ct = (e, t) => e ? to(V, e, t) : "";
    function ro(e, t) {
      t = Y(t);
      var r = t === "std::string";
      ne(e, { name: t, fromWireType: function(o) {
        var s = H[o >> 2], c = o + 4, l;
        if (r)
          for (var f = c, p = 0; p <= s; ++p) {
            var m = c + p;
            if (p == s || V[m] == 0) {
              var b = m - f, E = Ct(f, b);
              l === void 0 ? l = E : (l += String.fromCharCode(0), l += E), f = m + 1;
            }
          }
        else {
          for (var O = new Array(s), p = 0; p < s; ++p)
            O[p] = String.fromCharCode(V[c + p]);
          l = O.join("");
        }
        return ae(o), l;
      }, toWireType: function(o, s) {
        s instanceof ArrayBuffer && (s = new Uint8Array(s));
        var c, l = typeof s == "string";
        l || s instanceof Uint8Array || s instanceof Uint8ClampedArray || s instanceof Int8Array || F("Cannot pass non-string to std::string"), r && l ? c = Qt(s) : c = s.length;
        var f = $t(4 + c + 1), p = f + 4;
        if (H[f >> 2] = c, r && l)
          eo(s, p, c + 1);
        else if (l)
          for (var m = 0; m < c; ++m) {
            var b = s.charCodeAt(m);
            b > 255 && (ae(p), F("String has UTF-16 code units that do not fit in 8 bits")), V[p + m] = b;
          }
        else
          for (var m = 0; m < c; ++m)
            V[p + m] = s[m];
        return o !== null && o.push(ae, f), f;
      }, argPackAdvance: 8, readValueFromPointer: Ee, destructorFunction: function(o) {
        ae(o);
      } });
    }
    var Zt = typeof TextDecoder < "u" ? new TextDecoder("utf-16le") : void 0, no = (e, t) => {
      for (var r = e, o = r >> 1, s = o + t / 2; !(o >= s) && ve[o]; )
        ++o;
      if (r = o << 1, r - e > 32 && Zt)
        return Zt.decode(V.subarray(e, r));
      for (var c = "", l = 0; !(l >= t / 2); ++l) {
        var f = Z[e + l * 2 >> 1];
        if (f == 0)
          break;
        c += String.fromCharCode(f);
      }
      return c;
    }, oo = (e, t, r) => {
      if (r === void 0 && (r = 2147483647), r < 2)
        return 0;
      r -= 2;
      for (var o = t, s = r < e.length * 2 ? r / 2 : e.length, c = 0; c < s; ++c) {
        var l = e.charCodeAt(c);
        Z[t >> 1] = l, t += 2;
      }
      return Z[t >> 1] = 0, t - o;
    }, ao = (e) => e.length * 2, io = (e, t) => {
      for (var r = 0, o = ""; !(r >= t / 4); ) {
        var s = z[e + r * 4 >> 2];
        if (s == 0)
          break;
        if (++r, s >= 65536) {
          var c = s - 65536;
          o += String.fromCharCode(55296 | c >> 10, 56320 | c & 1023);
        } else
          o += String.fromCharCode(s);
      }
      return o;
    }, so = (e, t, r) => {
      if (r === void 0 && (r = 2147483647), r < 4)
        return 0;
      for (var o = t, s = o + r - 4, c = 0; c < e.length; ++c) {
        var l = e.charCodeAt(c);
        if (l >= 55296 && l <= 57343) {
          var f = e.charCodeAt(++c);
          l = 65536 + ((l & 1023) << 10) | f & 1023;
        }
        if (z[t >> 2] = l, t += 4, t + 4 > s)
          break;
      }
      return z[t >> 2] = 0, t - o;
    }, co = (e) => {
      for (var t = 0, r = 0; r < e.length; ++r) {
        var o = e.charCodeAt(r);
        o >= 55296 && o <= 57343 && ++r, t += 4;
      }
      return t;
    }, uo = function(e, t, r) {
      r = Y(r);
      var o, s, c, l, f;
      t === 2 ? (o = no, s = oo, l = ao, c = () => ve, f = 1) : t === 4 && (o = io, s = so, l = co, c = () => H, f = 2), ne(e, { name: r, fromWireType: function(p) {
        for (var m = H[p >> 2], b = c(), E, O = p + 4, k = 0; k <= m; ++k) {
          var W = p + 4 + k * t;
          if (k == m || b[W >> f] == 0) {
            var q = W - O, L = o(O, q);
            E === void 0 ? E = L : (E += String.fromCharCode(0), E += L), O = W + t;
          }
        }
        return ae(p), E;
      }, toWireType: function(p, m) {
        typeof m != "string" && F(`Cannot pass non-string to C++ string type ${r}`);
        var b = l(m), E = $t(4 + b + t);
        return H[E >> 2] = b >> f, s(m, E + 4, b + t), p !== null && p.push(ae, E), E;
      }, argPackAdvance: 8, readValueFromPointer: Ee, destructorFunction: function(p) {
        ae(p);
      } });
    };
    function lo(e, t, r, o, s, c) {
      Be[e] = { name: Y(t), rawConstructor: X(r, o), rawDestructor: X(s, c), fields: [] };
    }
    function fo(e, t, r, o, s, c, l, f, p, m) {
      Be[e].fields.push({ fieldName: Y(t), getterReturnType: r, getter: X(o, s), getterContext: c, setterArgumentType: l, setter: X(f, p), setterContext: m });
    }
    function po(e, t) {
      t = Y(t), ne(e, { isVoid: !0, name: t, argPackAdvance: 0, fromWireType: function() {
      }, toWireType: function(r, o) {
      } });
    }
    var ho = {};
    function vo(e) {
      var t = ho[e];
      return t === void 0 ? Y(e) : t;
    }
    function Kt() {
      if (typeof globalThis == "object")
        return globalThis;
      function e(t) {
        t.$$$embind_global$$$ = t;
        var r = typeof $$$embind_global$$$ == "object" && t.$$$embind_global$$$ == t;
        return r || delete t.$$$embind_global$$$, r;
      }
      if (typeof $$$embind_global$$$ == "object" || (typeof global == "object" && e(global) ? $$$embind_global$$$ = global : typeof self == "object" && e(self) && ($$$embind_global$$$ = self), typeof $$$embind_global$$$ == "object"))
        return $$$embind_global$$$;
      throw Error("unable to get global object.");
    }
    function mo(e) {
      return e === 0 ? le.toHandle(Kt()) : (e = vo(e), le.toHandle(Kt()[e]));
    }
    function yo(e) {
      e > 4 && (Q.get(e).refcount += 1);
    }
    function er(e, t) {
      var r = ge[e];
      return r === void 0 && F(t + " has unknown type " + qt(e)), r;
    }
    function go(e) {
      var t = new Array(e + 1);
      return function(r, o, s) {
        t[0] = r;
        for (var c = 0; c < e; ++c) {
          var l = er(H[o + c * 4 >> 2], "parameter " + c);
          t[c + 1] = l.readValueFromPointer(s), s += l.argPackAdvance;
        }
        var f = new (r.bind.apply(r, t))();
        return le.toHandle(f);
      };
    }
    var tr = {};
    function wo(e, t, r, o) {
      e = le.toValue(e);
      var s = tr[t];
      return s || (s = go(t), tr[t] = s), s(e, r, o);
    }
    function bo(e, t) {
      e = er(e, "_emval_take_value");
      var r = e.readValueFromPointer(t);
      return le.toHandle(r);
    }
    var Co = () => {
      Le("");
    }, _o = (e, t, r) => V.copyWithin(e, t, t + r), $o = () => 2147483648, So = (e) => {
      var t = M.buffer, r = e - t.byteLength + 65535 >>> 16;
      try {
        return M.grow(r), Ue(), 1;
      } catch (o) {
      }
    }, Po = (e) => {
      var t = V.length;
      e >>>= 0;
      var r = $o();
      if (e > r)
        return !1;
      for (var o = (p, m) => p + (m - p % m) % m, s = 1; s <= 4; s *= 2) {
        var c = t * (1 + 0.2 / s);
        c = Math.min(c, e + 100663296);
        var l = Math.min(r, o(Math.max(e, c), 65536)), f = So(l);
        if (f)
          return !0;
      }
      return !1;
    }, _t = {}, To = () => v || "./this.program", xe = () => {
      if (!xe.strings) {
        var e = (typeof navigator == "object" && navigator.languages && navigator.languages[0] || "C").replace("-", "_") + ".UTF-8", t = { USER: "web_user", LOGNAME: "web_user", PATH: "/", PWD: "/", HOME: "/home/web_user", LANG: e, _: To() };
        for (var r in _t)
          _t[r] === void 0 ? delete t[r] : t[r] = _t[r];
        var o = [];
        for (var r in t)
          o.push(`${r}=${t[r]}`);
        xe.strings = o;
      }
      return xe.strings;
    }, Eo = (e, t) => {
      for (var r = 0; r < e.length; ++r)
        U[t++ >> 0] = e.charCodeAt(r);
      U[t >> 0] = 0;
    }, Oo = (e, t) => {
      var r = 0;
      return xe().forEach(function(o, s) {
        var c = t + r;
        H[e + s * 4 >> 2] = c, Eo(o, c), r += o.length + 1;
      }), 0;
    }, Mo = (e, t) => {
      var r = xe();
      H[e >> 2] = r.length;
      var o = 0;
      return r.forEach(function(s) {
        o += s.length + 1;
      }), H[t >> 2] = o, 0;
    };
    function Ao(e) {
      return e;
    }
    var Qe = (e) => e % 4 === 0 && (e % 100 !== 0 || e % 400 === 0), Do = (e, t) => {
      for (var r = 0, o = 0; o <= t; r += e[o++])
        ;
      return r;
    }, rr = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], nr = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], xo = (e, t) => {
      for (var r = new Date(e.getTime()); t > 0; ) {
        var o = Qe(r.getFullYear()), s = r.getMonth(), c = (o ? rr : nr)[s];
        if (t > c - r.getDate())
          t -= c - r.getDate() + 1, r.setDate(1), s < 11 ? r.setMonth(s + 1) : (r.setMonth(0), r.setFullYear(r.getFullYear() + 1));
        else
          return r.setDate(r.getDate() + t), r;
      }
      return r;
    };
    function Ro(e, t, r) {
      var o = r > 0 ? r : Qt(e) + 1, s = new Array(o), c = Jt(e, s, 0, s.length);
      return t && (s.length = c), s;
    }
    var ko = (e, t) => {
      U.set(e, t);
    }, Fo = (e, t, r, o) => {
      var s = z[o + 40 >> 2], c = { tm_sec: z[o >> 2], tm_min: z[o + 4 >> 2], tm_hour: z[o + 8 >> 2], tm_mday: z[o + 12 >> 2], tm_mon: z[o + 16 >> 2], tm_year: z[o + 20 >> 2], tm_wday: z[o + 24 >> 2], tm_yday: z[o + 28 >> 2], tm_isdst: z[o + 32 >> 2], tm_gmtoff: z[o + 36 >> 2], tm_zone: s ? Ct(s) : "" }, l = Ct(r), f = { "%c": "%a %b %d %H:%M:%S %Y", "%D": "%m/%d/%y", "%F": "%Y-%m-%d", "%h": "%b", "%r": "%I:%M:%S %p", "%R": "%H:%M", "%T": "%H:%M:%S", "%x": "%m/%d/%y", "%X": "%H:%M:%S", "%Ec": "%c", "%EC": "%C", "%Ex": "%m/%d/%y", "%EX": "%H:%M:%S", "%Ey": "%y", "%EY": "%Y", "%Od": "%d", "%Oe": "%e", "%OH": "%H", "%OI": "%I", "%Om": "%m", "%OM": "%M", "%OS": "%S", "%Ou": "%u", "%OU": "%U", "%OV": "%V", "%Ow": "%w", "%OW": "%W", "%Oy": "%y" };
      for (var p in f)
        l = l.replace(new RegExp(p, "g"), f[p]);
      var m = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], b = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
      function E(g, P, B) {
        for (var G = typeof g == "number" ? g.toString() : g || ""; G.length < P; )
          G = B[0] + G;
        return G;
      }
      function O(g, P) {
        return E(g, P, "0");
      }
      function k(g, P) {
        function B(be) {
          return be < 0 ? -1 : be > 0 ? 1 : 0;
        }
        var G;
        return (G = B(g.getFullYear() - P.getFullYear())) === 0 && (G = B(g.getMonth() - P.getMonth())) === 0 && (G = B(g.getDate() - P.getDate())), G;
      }
      function W(g) {
        switch (g.getDay()) {
          case 0:
            return new Date(g.getFullYear() - 1, 11, 29);
          case 1:
            return g;
          case 2:
            return new Date(g.getFullYear(), 0, 3);
          case 3:
            return new Date(g.getFullYear(), 0, 2);
          case 4:
            return new Date(g.getFullYear(), 0, 1);
          case 5:
            return new Date(g.getFullYear() - 1, 11, 31);
          case 6:
            return new Date(g.getFullYear() - 1, 11, 30);
        }
      }
      function q(g) {
        var P = xo(new Date(g.tm_year + 1900, 0, 1), g.tm_yday), B = new Date(P.getFullYear(), 0, 4), G = new Date(P.getFullYear() + 1, 0, 4), be = W(B), Ze = W(G);
        return k(be, P) <= 0 ? k(Ze, P) <= 0 ? P.getFullYear() + 1 : P.getFullYear() : P.getFullYear() - 1;
      }
      var L = { "%a": (g) => m[g.tm_wday].substring(0, 3), "%A": (g) => m[g.tm_wday], "%b": (g) => b[g.tm_mon].substring(0, 3), "%B": (g) => b[g.tm_mon], "%C": (g) => {
        var P = g.tm_year + 1900;
        return O(P / 100 | 0, 2);
      }, "%d": (g) => O(g.tm_mday, 2), "%e": (g) => E(g.tm_mday, 2, " "), "%g": (g) => q(g).toString().substring(2), "%G": (g) => q(g), "%H": (g) => O(g.tm_hour, 2), "%I": (g) => {
        var P = g.tm_hour;
        return P == 0 ? P = 12 : P > 12 && (P -= 12), O(P, 2);
      }, "%j": (g) => O(g.tm_mday + Do(Qe(g.tm_year + 1900) ? rr : nr, g.tm_mon - 1), 3), "%m": (g) => O(g.tm_mon + 1, 2), "%M": (g) => O(g.tm_min, 2), "%n": () => `
`, "%p": (g) => g.tm_hour >= 0 && g.tm_hour < 12 ? "AM" : "PM", "%S": (g) => O(g.tm_sec, 2), "%t": () => "	", "%u": (g) => g.tm_wday || 7, "%U": (g) => {
        var P = g.tm_yday + 7 - g.tm_wday;
        return O(Math.floor(P / 7), 2);
      }, "%V": (g) => {
        var P = Math.floor((g.tm_yday + 7 - (g.tm_wday + 6) % 7) / 7);
        if ((g.tm_wday + 371 - g.tm_yday - 2) % 7 <= 2 && P++, P) {
          if (P == 53) {
            var B = (g.tm_wday + 371 - g.tm_yday) % 7;
            B != 4 && (B != 3 || !Qe(g.tm_year)) && (P = 1);
          }
        } else {
          P = 52;
          var G = (g.tm_wday + 7 - g.tm_yday - 1) % 7;
          (G == 4 || G == 5 && Qe(g.tm_year % 400 - 1)) && P++;
        }
        return O(P, 2);
      }, "%w": (g) => g.tm_wday, "%W": (g) => {
        var P = g.tm_yday + 7 - (g.tm_wday + 6) % 7;
        return O(Math.floor(P / 7), 2);
      }, "%y": (g) => (g.tm_year + 1900).toString().substring(2), "%Y": (g) => g.tm_year + 1900, "%z": (g) => {
        var P = g.tm_gmtoff, B = P >= 0;
        return P = Math.abs(P) / 60, P = P / 60 * 100 + P % 60, (B ? "+" : "-") + ("0000" + P).slice(-4);
      }, "%Z": (g) => g.tm_zone, "%%": () => "%" };
      l = l.replace(/%%/g, "\0\0");
      for (var p in L)
        l.includes(p) && (l = l.replace(new RegExp(p, "g"), L[p](c)));
      l = l.replace(/\0\0/g, "%");
      var N = Ro(l, !1);
      return N.length > t ? 0 : (ko(N, e), N.length - 1);
    }, Io = (e, t, r, o, s) => Fo(e, t, r, o);
    kt = a.InternalError = class extends Error {
      constructor(e) {
        super(e), this.name = "InternalError";
      }
    }, un(), $e = a.BindingError = class extends Error {
      constructor(e) {
        super(e), this.name = "BindingError";
      }
    }, Tn(), gn(), In(), Gt = a.UnboundTypeError = Ln(Error, "UnboundTypeError"), Bn(), qn();
    var Uo = { q: Qr, u: Xr, a: Kr, h: en, l: tn, I: rn, P: nn, n: on, ba: an, d: Zr, oa: sn, Y: cn, fa: fn, na: Hn, ma: Vn, D: zn, ea: Nn, W: Jn, J: Qn, w: Zn, s: Kn, V: ro, L: uo, Q: lo, pa: fo, ga: po, U: Yt, la: mo, R: yo, ia: wo, ka: bo, K: Co, da: _o, ca: Po, $: Oo, aa: Mo, H: ra, T: fa, B: oa, p: Ko, b: jo, C: ta, ha: ia, c: zo, j: Go, i: Ho, x: na, O: ea, v: Xo, G: ca, N: ua, A: aa, F: da, Z: ha, X: va, k: Bo, f: Vo, e: Lo, g: Wo, M: la, m: Qo, o: qo, S: No, t: Jo, ja: Zo, y: sa, r: Yo, E: pa, z: Ao, _: Io };
    Jr();
    var ae = a._free = (e) => (ae = a._free = T.sa)(e), $t = a._malloc = (e) => ($t = a._malloc = T.ta)(e), or = (e) => (or = T.va)(e);
    a.__embind_initialize_bindings = () => (a.__embind_initialize_bindings = T.wa)();
    var D = (e, t) => (D = T.xa)(e, t), Re = (e) => (Re = T.ya)(e), x = () => (x = T.za)(), R = (e) => (R = T.Aa)(e), ar = (e) => (ar = T.Ba)(e), ir = (e) => (ir = T.Ca)(e), sr = (e, t, r) => (sr = T.Da)(e, t, r), cr = (e) => (cr = T.Ea)(e);
    a.dynCall_viijii = (e, t, r, o, s, c, l) => (a.dynCall_viijii = T.Fa)(e, t, r, o, s, c, l);
    var ur = a.dynCall_jiii = (e, t, r, o) => (ur = a.dynCall_jiii = T.Ga)(e, t, r, o), lr = a.dynCall_jiiii = (e, t, r, o, s) => (lr = a.dynCall_jiiii = T.Ha)(e, t, r, o, s);
    a.dynCall_iiiiij = (e, t, r, o, s, c, l) => (a.dynCall_iiiiij = T.Ia)(e, t, r, o, s, c, l), a.dynCall_iiiiijj = (e, t, r, o, s, c, l, f, p) => (a.dynCall_iiiiijj = T.Ja)(e, t, r, o, s, c, l, f, p), a.dynCall_iiiiiijj = (e, t, r, o, s, c, l, f, p, m) => (a.dynCall_iiiiiijj = T.Ka)(e, t, r, o, s, c, l, f, p, m);
    function jo(e, t) {
      var r = x();
      try {
        return I(e)(t);
      } catch (o) {
        if (R(r), o !== o + 0)
          throw o;
        D(1, 0);
      }
    }
    function Wo(e, t, r, o) {
      var s = x();
      try {
        I(e)(t, r, o);
      } catch (c) {
        if (R(s), c !== c + 0)
          throw c;
        D(1, 0);
      }
    }
    function Lo(e, t, r) {
      var o = x();
      try {
        I(e)(t, r);
      } catch (s) {
        if (R(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function Ho(e, t, r, o, s) {
      var c = x();
      try {
        return I(e)(t, r, o, s);
      } catch (l) {
        if (R(c), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    function Vo(e, t) {
      var r = x();
      try {
        I(e)(t);
      } catch (o) {
        if (R(r), o !== o + 0)
          throw o;
        D(1, 0);
      }
    }
    function zo(e, t, r) {
      var o = x();
      try {
        return I(e)(t, r);
      } catch (s) {
        if (R(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function Bo(e) {
      var t = x();
      try {
        I(e)();
      } catch (r) {
        if (R(t), r !== r + 0)
          throw r;
        D(1, 0);
      }
    }
    function Go(e, t, r, o) {
      var s = x();
      try {
        return I(e)(t, r, o);
      } catch (c) {
        if (R(s), c !== c + 0)
          throw c;
        D(1, 0);
      }
    }
    function qo(e, t, r, o, s, c) {
      var l = x();
      try {
        I(e)(t, r, o, s, c);
      } catch (f) {
        if (R(l), f !== f + 0)
          throw f;
        D(1, 0);
      }
    }
    function No(e, t, r, o, s, c, l) {
      var f = x();
      try {
        I(e)(t, r, o, s, c, l);
      } catch (p) {
        if (R(f), p !== p + 0)
          throw p;
        D(1, 0);
      }
    }
    function Yo(e, t, r, o, s, c, l, f, p, m, b) {
      var E = x();
      try {
        I(e)(t, r, o, s, c, l, f, p, m, b);
      } catch (O) {
        if (R(E), O !== O + 0)
          throw O;
        D(1, 0);
      }
    }
    function Jo(e, t, r, o, s, c, l, f) {
      var p = x();
      try {
        I(e)(t, r, o, s, c, l, f);
      } catch (m) {
        if (R(p), m !== m + 0)
          throw m;
        D(1, 0);
      }
    }
    function Qo(e, t, r, o, s) {
      var c = x();
      try {
        I(e)(t, r, o, s);
      } catch (l) {
        if (R(c), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    function Xo(e, t, r, o, s, c, l) {
      var f = x();
      try {
        return I(e)(t, r, o, s, c, l);
      } catch (p) {
        if (R(f), p !== p + 0)
          throw p;
        D(1, 0);
      }
    }
    function Zo(e, t, r, o, s, c, l, f, p) {
      var m = x();
      try {
        I(e)(t, r, o, s, c, l, f, p);
      } catch (b) {
        if (R(m), b !== b + 0)
          throw b;
        D(1, 0);
      }
    }
    function Ko(e) {
      var t = x();
      try {
        return I(e)();
      } catch (r) {
        if (R(t), r !== r + 0)
          throw r;
        D(1, 0);
      }
    }
    function ea(e, t, r, o, s, c, l) {
      var f = x();
      try {
        return I(e)(t, r, o, s, c, l);
      } catch (p) {
        if (R(f), p !== p + 0)
          throw p;
        D(1, 0);
      }
    }
    function ta(e, t, r, o) {
      var s = x();
      try {
        return I(e)(t, r, o);
      } catch (c) {
        if (R(s), c !== c + 0)
          throw c;
        D(1, 0);
      }
    }
    function ra(e, t, r, o) {
      var s = x();
      try {
        return I(e)(t, r, o);
      } catch (c) {
        if (R(s), c !== c + 0)
          throw c;
        D(1, 0);
      }
    }
    function na(e, t, r, o, s, c) {
      var l = x();
      try {
        return I(e)(t, r, o, s, c);
      } catch (f) {
        if (R(l), f !== f + 0)
          throw f;
        D(1, 0);
      }
    }
    function oa(e, t, r, o, s, c) {
      var l = x();
      try {
        return I(e)(t, r, o, s, c);
      } catch (f) {
        if (R(l), f !== f + 0)
          throw f;
        D(1, 0);
      }
    }
    function aa(e, t, r, o, s, c, l, f, p, m) {
      var b = x();
      try {
        return I(e)(t, r, o, s, c, l, f, p, m);
      } catch (E) {
        if (R(b), E !== E + 0)
          throw E;
        D(1, 0);
      }
    }
    function ia(e, t, r) {
      var o = x();
      try {
        return I(e)(t, r);
      } catch (s) {
        if (R(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function sa(e, t, r, o, s, c, l, f, p, m) {
      var b = x();
      try {
        I(e)(t, r, o, s, c, l, f, p, m);
      } catch (E) {
        if (R(b), E !== E + 0)
          throw E;
        D(1, 0);
      }
    }
    function ca(e, t, r, o, s, c, l, f) {
      var p = x();
      try {
        return I(e)(t, r, o, s, c, l, f);
      } catch (m) {
        if (R(p), m !== m + 0)
          throw m;
        D(1, 0);
      }
    }
    function ua(e, t, r, o, s, c, l, f, p) {
      var m = x();
      try {
        return I(e)(t, r, o, s, c, l, f, p);
      } catch (b) {
        if (R(m), b !== b + 0)
          throw b;
        D(1, 0);
      }
    }
    function la(e, t, r, o, s, c, l) {
      var f = x();
      try {
        I(e)(t, r, o, s, c, l);
      } catch (p) {
        if (R(f), p !== p + 0)
          throw p;
        D(1, 0);
      }
    }
    function fa(e, t, r, o) {
      var s = x();
      try {
        return I(e)(t, r, o);
      } catch (c) {
        if (R(s), c !== c + 0)
          throw c;
        D(1, 0);
      }
    }
    function da(e, t, r, o, s, c, l, f, p, m, b, E) {
      var O = x();
      try {
        return I(e)(t, r, o, s, c, l, f, p, m, b, E);
      } catch (k) {
        if (R(O), k !== k + 0)
          throw k;
        D(1, 0);
      }
    }
    function pa(e, t, r, o, s, c, l, f, p, m, b, E, O, k, W, q) {
      var L = x();
      try {
        I(e)(t, r, o, s, c, l, f, p, m, b, E, O, k, W, q);
      } catch (N) {
        if (R(L), N !== N + 0)
          throw N;
        D(1, 0);
      }
    }
    function ha(e, t, r, o) {
      var s = x();
      try {
        return ur(e, t, r, o);
      } catch (c) {
        if (R(s), c !== c + 0)
          throw c;
        D(1, 0);
      }
    }
    function va(e, t, r, o, s) {
      var c = x();
      try {
        return lr(e, t, r, o, s);
      } catch (l) {
        if (R(c), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    var Xe;
    me = function e() {
      Xe || fr(), Xe || (me = e);
    };
    function fr() {
      if (te > 0 || (it(), te > 0))
        return;
      function e() {
        Xe || (Xe = !0, a.calledRun = !0, !j && (ce(), u(a), a.onRuntimeInitialized && a.onRuntimeInitialized(), K()));
      }
      a.setStatus ? (a.setStatus("Running..."), setTimeout(function() {
        setTimeout(function() {
          a.setStatus("");
        }, 1), e();
      }, 1)) : e();
    }
    if (a.preInit)
      for (typeof a.preInit == "function" && (a.preInit = [a.preInit]); a.preInit.length > 0; )
        a.preInit.pop()();
    return fr(), i.ready;
  };
})();
function za(n) {
  return Mr(Ar, n);
}
async function Ba(n, {
  tryHarder: i = de.tryHarder,
  formats: a = de.formats,
  maxSymbols: u = de.maxSymbols
} = de) {
  return La(
    n,
    {
      tryHarder: i,
      formats: a,
      maxSymbols: u
    },
    Ar
  );
}
const Dr = /* @__PURE__ */ new Map([
  ["aztec", "Aztec"],
  ["code_128", "Code128"],
  ["code_39", "Code39"],
  ["code_93", "Code93"],
  ["codabar", "Codabar"],
  ["data_matrix", "DataMatrix"],
  ["ean_13", "EAN-13"],
  ["ean_8", "EAN-8"],
  ["itf", "ITF"],
  ["pdf417", "PDF417"],
  ["qr_code", "QRCode"],
  ["upc_a", "UPC-A"],
  ["upc_e", "UPC-E"]
]);
function Ga(n) {
  for (const [i, a] of Dr)
    if (n === a)
      return i;
  return "unknown";
}
var tt;
class at {
  constructor(i = {}) {
    $a(this, tt, void 0);
    var a;
    try {
      const u = (a = i == null ? void 0 : i.formats) == null ? void 0 : a.filter(
        (d) => d !== "unknown"
      );
      if ((u == null ? void 0 : u.length) === 0)
        throw new TypeError("Hint option provided, but is empty.");
      u == null || u.forEach((d) => {
        if (!pr.includes(d))
          throw new TypeError(
            `Failed to read the 'formats' property from 'BarcodeDetectorOptions': The provided value '${d}' is not a valid enum value of type BarcodeFormat.`
          );
      }), za().catch(() => {
      }), Sa(this, tt, u ?? []);
    } catch (u) {
      throw hr(
        u,
        "Failed to construct 'BarcodeDetector'"
      );
    }
  }
  static async getSupportedFormats() {
    return pr.filter((i) => i !== "unknown");
  }
  async detect(i) {
    try {
      const a = await xa(i);
      if (a === null)
        return [];
      let u;
      try {
        u = await Ba(a, {
          tryHarder: !0,
          formats: _a(this, tt).map(
            (d) => Dr.get(d)
          )
        });
      } catch (d) {
        throw new DOMException(
          "Barcode detection service unavailable. Use 'setZXingModuleOverrides' in offline or strict CSP environments.",
          "NotSupportedError"
        );
      }
      return u.map((d) => {
        const {
          topLeft: { x: h, y: v },
          topRight: { x: w, y: C },
          bottomLeft: { x: y, y: _ },
          bottomRight: { x: S, y: $ }
        } = d.position, A = Math.min(h, w, y, S), M = Math.min(v, C, _, $), T = Math.max(h, w, y, S), j = Math.max(v, C, _, $);
        return {
          boundingBox: new DOMRectReadOnly(
            A,
            M,
            T - A,
            j - M
          ),
          rawValue: new TextDecoder().decode(d.bytes),
          format: Ga(d.format),
          cornerPoints: [
            {
              x: h,
              y: v
            },
            {
              x: w,
              y: C
            },
            {
              x: S,
              y: $
            },
            {
              x: y,
              y: _
            }
          ]
        };
      });
    } catch (a) {
      throw hr(
        a,
        "Failed to execute 'detect' on 'BarcodeDetector'"
      );
    }
  }
}
tt = /* @__PURE__ */ new WeakMap();
const xr = (n, i, a = "error") => {
  let u, d;
  const h = new Promise(
    (v, w) => {
      u = v, d = w, n.addEventListener(i, u), n.addEventListener(a, d);
    }
  );
  return h.finally(() => {
    n.removeEventListener(i, u), n.removeEventListener(a, d);
  }), h;
}, gr = (n) => new Promise((i) => setTimeout(i, n));
class qa extends Error {
  constructor() {
    super("can't process cross-origin image"), this.name = "DropImageFetchError";
  }
}
class Rr extends Error {
  constructor() {
    super("this browser has no Stream API support"), this.name = "StreamApiNotSupportedError";
  }
}
class Na extends Error {
  constructor() {
    super(
      "camera access is only permitted in secure context. Use HTTPS or localhost rather than HTTP."
    ), this.name = "InsecureContextError";
  }
}
class Ya extends Error {
  constructor() {
    super("Loading camera stream timed out after 3 seconds. If you are on iOS in PWA mode, this is a known issue (see https://github.com/gruhn/vue-qrcode-reader/issues/298)"), this.name = "StreamLoadTimeoutError";
  }
}
let Tt;
const Ja = (n) => {
  Tt = new at({ formats: n });
}, Qa = async (n, {
  detectHandler: i,
  locateHandler: a,
  minDelay: u,
  formats: d
}) => {
  Tt = new at({ formats: d });
  const h = (v) => async (w) => {
    if (n.readyState > 1) {
      const { lastScanned: C, contentBefore: y, lastScanHadContent: _ } = v;
      if (w - C < u)
        window.requestAnimationFrame(h(v));
      else {
        const S = await Tt.detect(n), $ = S.some((T) => !y.includes(T.rawValue));
        $ && i(S);
        const A = S.length > 0;
        A && a(S), !A && _ && a(S);
        const M = {
          lastScanned: w,
          lastScanHadContent: A,
          // It can happen that a QR code is constantly in view of the camera but
          // maybe a scanned frame is a bit blurry and we detect nothing but in the
          // next frame we detect the code again. We also want to avoid emitting
          // a `detect` event in such a case. So we don't reset `contentBefore`,
          // if we detect nothing, only if we detect something new.
          contentBefore: $ ? S.map((T) => T.rawValue) : y
        };
        window.requestAnimationFrame(h(M));
      }
    }
  };
  h({
    lastScanned: performance.now(),
    contentBefore: [],
    lastScanHadContent: !1
  })(performance.now());
}, Xa = async (n) => {
  if (n.startsWith("http") && n.includes(location.host) === !1)
    throw new qa();
  const i = document.createElement("img");
  return i.src = n, await xr(i, "load"), i;
}, kr = async (n, i = ["qr_code"]) => await new at({
  formats: i
}).detect(n), Za = async (n, i = ["qr_code"]) => {
  const a = new at({
    formats: i
  }), u = await Xa(n);
  return await a.detect(u);
};
var Fr = {}, J = {};
Object.defineProperty(J, "__esModule", {
  value: !0
});
J.compactObject = jr;
J.deprecated = si;
var Ka = J.detectBrowser = ci;
J.disableLog = oi;
J.disableWarnings = ai;
J.extractVersion = rt;
J.filterStats = ui;
J.log = ii;
J.walkStats = nt;
J.wrapPeerConnectionEvent = ni;
function ei(n, i, a) {
  return i = ti(i), i in n ? Object.defineProperty(n, i, { value: a, enumerable: !0, configurable: !0, writable: !0 }) : n[i] = a, n;
}
function ti(n) {
  var i = ri(n, "string");
  return pe(i) === "symbol" ? i : String(i);
}
function ri(n, i) {
  if (pe(n) !== "object" || n === null)
    return n;
  var a = n[Symbol.toPrimitive];
  if (a !== void 0) {
    var u = a.call(n, i || "default");
    if (pe(u) !== "object")
      return u;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (i === "string" ? String : Number)(n);
}
function pe(n) {
  "@babel/helpers - typeof";
  return pe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, pe(n);
}
var Ir = !0, Ur = !0;
function rt(n, i, a) {
  var u = n.match(i);
  return u && u.length >= a && parseInt(u[a], 10);
}
function ni(n, i, a) {
  if (n.RTCPeerConnection) {
    var u = n.RTCPeerConnection.prototype, d = u.addEventListener;
    u.addEventListener = function(v, w) {
      if (v !== i)
        return d.apply(this, arguments);
      var C = function(_) {
        var S = a(_);
        S && (w.handleEvent ? w.handleEvent(S) : w(S));
      };
      return this._eventMap = this._eventMap || {}, this._eventMap[i] || (this._eventMap[i] = /* @__PURE__ */ new Map()), this._eventMap[i].set(w, C), d.apply(this, [v, C]);
    };
    var h = u.removeEventListener;
    u.removeEventListener = function(v, w) {
      if (v !== i || !this._eventMap || !this._eventMap[i])
        return h.apply(this, arguments);
      if (!this._eventMap[i].has(w))
        return h.apply(this, arguments);
      var C = this._eventMap[i].get(w);
      return this._eventMap[i].delete(w), this._eventMap[i].size === 0 && delete this._eventMap[i], Object.keys(this._eventMap).length === 0 && delete this._eventMap, h.apply(this, [v, C]);
    }, Object.defineProperty(u, "on" + i, {
      get: function() {
        return this["_on" + i];
      },
      set: function(w) {
        this["_on" + i] && (this.removeEventListener(i, this["_on" + i]), delete this["_on" + i]), w && this.addEventListener(i, this["_on" + i] = w);
      },
      enumerable: !0,
      configurable: !0
    });
  }
}
function oi(n) {
  return typeof n != "boolean" ? new Error("Argument type: " + pe(n) + ". Please use a boolean.") : (Ir = n, n ? "adapter.js logging disabled" : "adapter.js logging enabled");
}
function ai(n) {
  return typeof n != "boolean" ? new Error("Argument type: " + pe(n) + ". Please use a boolean.") : (Ur = !n, "adapter.js deprecation warnings " + (n ? "disabled" : "enabled"));
}
function ii() {
  if ((typeof window > "u" ? "undefined" : pe(window)) === "object") {
    if (Ir)
      return;
    typeof console < "u" && typeof console.log == "function" && console.log.apply(console, arguments);
  }
}
function si(n, i) {
  Ur && console.warn(n + " is deprecated, please use " + i + " instead.");
}
function ci(n) {
  var i = {
    browser: null,
    version: null
  };
  if (typeof n > "u" || !n.navigator)
    return i.browser = "Not a browser.", i;
  var a = n.navigator;
  if (a.mozGetUserMedia)
    i.browser = "firefox", i.version = rt(a.userAgent, /Firefox\/(\d+)\./, 1);
  else if (a.webkitGetUserMedia || n.isSecureContext === !1 && n.webkitRTCPeerConnection)
    i.browser = "chrome", i.version = rt(a.userAgent, /Chrom(e|ium)\/(\d+)\./, 2);
  else if (n.RTCPeerConnection && a.userAgent.match(/AppleWebKit\/(\d+)\./))
    i.browser = "safari", i.version = rt(a.userAgent, /AppleWebKit\/(\d+)\./, 1), i.supportsUnifiedPlan = n.RTCRtpTransceiver && "currentDirection" in n.RTCRtpTransceiver.prototype;
  else
    return i.browser = "Not a supported browser.", i;
  return i;
}
function wr(n) {
  return Object.prototype.toString.call(n) === "[object Object]";
}
function jr(n) {
  return wr(n) ? Object.keys(n).reduce(function(i, a) {
    var u = wr(n[a]), d = u ? jr(n[a]) : n[a], h = u && !Object.keys(d).length;
    return d === void 0 || h ? i : Object.assign(i, ei({}, a, d));
  }, {}) : n;
}
function nt(n, i, a) {
  !i || a.has(i.id) || (a.set(i.id, i), Object.keys(i).forEach(function(u) {
    u.endsWith("Id") ? nt(n, n.get(i[u]), a) : u.endsWith("Ids") && i[u].forEach(function(d) {
      nt(n, n.get(d), a);
    });
  }));
}
function ui(n, i, a) {
  var u = a ? "outbound-rtp" : "inbound-rtp", d = /* @__PURE__ */ new Map();
  if (i === null)
    return d;
  var h = [];
  return n.forEach(function(v) {
    v.type === "track" && v.trackIdentifier === i.id && h.push(v);
  }), h.forEach(function(v) {
    n.forEach(function(w) {
      w.type === u && w.trackId === v.id && nt(n, w, d);
    });
  }), d;
}
Object.defineProperty(Fr, "__esModule", {
  value: !0
});
var li = Fr.shimGetUserMedia = pi, fi = di(J);
function Wr(n) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (Wr = function(d) {
    return d ? a : i;
  })(n);
}
function di(n, i) {
  if (!i && n && n.__esModule)
    return n;
  if (n === null || fe(n) !== "object" && typeof n != "function")
    return { default: n };
  var a = Wr(i);
  if (a && a.has(n))
    return a.get(n);
  var u = {}, d = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in n)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(n, h)) {
      var v = d ? Object.getOwnPropertyDescriptor(n, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(u, h, v) : u[h] = n[h];
    }
  return u.default = n, a && a.set(n, u), u;
}
function fe(n) {
  "@babel/helpers - typeof";
  return fe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, fe(n);
}
var br = fi.log;
function pi(n, i) {
  var a = n && n.navigator;
  if (a.mediaDevices) {
    var u = function(y) {
      if (fe(y) !== "object" || y.mandatory || y.optional)
        return y;
      var _ = {};
      return Object.keys(y).forEach(function(S) {
        if (!(S === "require" || S === "advanced" || S === "mediaSource")) {
          var $ = fe(y[S]) === "object" ? y[S] : {
            ideal: y[S]
          };
          $.exact !== void 0 && typeof $.exact == "number" && ($.min = $.max = $.exact);
          var A = function(j, U) {
            return j ? j + U.charAt(0).toUpperCase() + U.slice(1) : U === "deviceId" ? "sourceId" : U;
          };
          if ($.ideal !== void 0) {
            _.optional = _.optional || [];
            var M = {};
            typeof $.ideal == "number" ? (M[A("min", S)] = $.ideal, _.optional.push(M), M = {}, M[A("max", S)] = $.ideal, _.optional.push(M)) : (M[A("", S)] = $.ideal, _.optional.push(M));
          }
          $.exact !== void 0 && typeof $.exact != "number" ? (_.mandatory = _.mandatory || {}, _.mandatory[A("", S)] = $.exact) : ["min", "max"].forEach(function(T) {
            $[T] !== void 0 && (_.mandatory = _.mandatory || {}, _.mandatory[A(T, S)] = $[T]);
          });
        }
      }), y.advanced && (_.optional = (_.optional || []).concat(y.advanced)), _;
    }, d = function(y, _) {
      if (i.version >= 61)
        return _(y);
      if (y = JSON.parse(JSON.stringify(y)), y && fe(y.audio) === "object") {
        var S = function(j, U, V) {
          U in j && !(V in j) && (j[V] = j[U], delete j[U]);
        };
        y = JSON.parse(JSON.stringify(y)), S(y.audio, "autoGainControl", "googAutoGainControl"), S(y.audio, "noiseSuppression", "googNoiseSuppression"), y.audio = u(y.audio);
      }
      if (y && fe(y.video) === "object") {
        var $ = y.video.facingMode;
        $ = $ && (fe($) === "object" ? $ : {
          ideal: $
        });
        var A = i.version < 66;
        if ($ && ($.exact === "user" || $.exact === "environment" || $.ideal === "user" || $.ideal === "environment") && !(a.mediaDevices.getSupportedConstraints && a.mediaDevices.getSupportedConstraints().facingMode && !A)) {
          delete y.video.facingMode;
          var M;
          if ($.exact === "environment" || $.ideal === "environment" ? M = ["back", "rear"] : ($.exact === "user" || $.ideal === "user") && (M = ["front"]), M)
            return a.mediaDevices.enumerateDevices().then(function(T) {
              T = T.filter(function(U) {
                return U.kind === "videoinput";
              });
              var j = T.find(function(U) {
                return M.some(function(V) {
                  return U.label.toLowerCase().includes(V);
                });
              });
              return !j && T.length && M.includes("back") && (j = T[T.length - 1]), j && (y.video.deviceId = $.exact ? {
                exact: j.deviceId
              } : {
                ideal: j.deviceId
              }), y.video = u(y.video), br("chrome: " + JSON.stringify(y)), _(y);
            });
        }
        y.video = u(y.video);
      }
      return br("chrome: " + JSON.stringify(y)), _(y);
    }, h = function(y) {
      return i.version >= 64 ? y : {
        name: {
          PermissionDeniedError: "NotAllowedError",
          PermissionDismissedError: "NotAllowedError",
          InvalidStateError: "NotAllowedError",
          DevicesNotFoundError: "NotFoundError",
          ConstraintNotSatisfiedError: "OverconstrainedError",
          TrackStartError: "NotReadableError",
          MediaDeviceFailedDueToShutdown: "NotAllowedError",
          MediaDeviceKillSwitchOn: "NotAllowedError",
          TabCaptureError: "AbortError",
          ScreenCaptureError: "AbortError",
          DeviceCaptureError: "AbortError"
        }[y.name] || y.name,
        message: y.message,
        constraint: y.constraint || y.constraintName,
        toString: function() {
          return this.name + (this.message && ": ") + this.message;
        }
      };
    }, v = function(y, _, S) {
      d(y, function($) {
        a.webkitGetUserMedia($, _, function(A) {
          S && S(h(A));
        });
      });
    };
    if (a.getUserMedia = v.bind(a), a.mediaDevices.getUserMedia) {
      var w = a.mediaDevices.getUserMedia.bind(a.mediaDevices);
      a.mediaDevices.getUserMedia = function(C) {
        return d(C, function(y) {
          return w(y).then(function(_) {
            if (y.audio && !_.getAudioTracks().length || y.video && !_.getVideoTracks().length)
              throw _.getTracks().forEach(function(S) {
                S.stop();
              }), new DOMException("", "NotFoundError");
            return _;
          }, function(_) {
            return Promise.reject(h(_));
          });
        });
      };
    }
  }
}
var Lr = {};
Object.defineProperty(Lr, "__esModule", {
  value: !0
});
var hi = Lr.shimGetUserMedia = yi, vi = mi(J);
function Hr(n) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (Hr = function(d) {
    return d ? a : i;
  })(n);
}
function mi(n, i) {
  if (!i && n && n.__esModule)
    return n;
  if (n === null || Pe(n) !== "object" && typeof n != "function")
    return { default: n };
  var a = Hr(i);
  if (a && a.has(n))
    return a.get(n);
  var u = {}, d = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in n)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(n, h)) {
      var v = d ? Object.getOwnPropertyDescriptor(n, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(u, h, v) : u[h] = n[h];
    }
  return u.default = n, a && a.set(n, u), u;
}
function Pe(n) {
  "@babel/helpers - typeof";
  return Pe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, Pe(n);
}
function yi(n, i) {
  var a = n && n.navigator, u = n && n.MediaStreamTrack;
  if (a.getUserMedia = function(C, y, _) {
    vi.deprecated("navigator.getUserMedia", "navigator.mediaDevices.getUserMedia"), a.mediaDevices.getUserMedia(C).then(y, _);
  }, !(i.version > 55 && "autoGainControl" in a.mediaDevices.getSupportedConstraints())) {
    var d = function(y, _, S) {
      _ in y && !(S in y) && (y[S] = y[_], delete y[_]);
    }, h = a.mediaDevices.getUserMedia.bind(a.mediaDevices);
    if (a.mediaDevices.getUserMedia = function(C) {
      return Pe(C) === "object" && Pe(C.audio) === "object" && (C = JSON.parse(JSON.stringify(C)), d(C.audio, "autoGainControl", "mozAutoGainControl"), d(C.audio, "noiseSuppression", "mozNoiseSuppression")), h(C);
    }, u && u.prototype.getSettings) {
      var v = u.prototype.getSettings;
      u.prototype.getSettings = function() {
        var C = v.apply(this, arguments);
        return d(C, "mozAutoGainControl", "autoGainControl"), d(C, "mozNoiseSuppression", "noiseSuppression"), C;
      };
    }
    if (u && u.prototype.applyConstraints) {
      var w = u.prototype.applyConstraints;
      u.prototype.applyConstraints = function(C) {
        return this.kind === "audio" && Pe(C) === "object" && (C = JSON.parse(JSON.stringify(C)), d(C, "autoGainControl", "mozAutoGainControl"), d(C, "noiseSuppression", "mozNoiseSuppression")), w.apply(this, [C]);
      };
    }
  }
}
var ee = {};
Object.defineProperty(ee, "__esModule", {
  value: !0
});
ee.shimAudioContext = Ei;
ee.shimCallbacksAPI = _i;
ee.shimConstraints = Br;
ee.shimCreateOfferLegacy = Ti;
var gi = ee.shimGetUserMedia = $i;
ee.shimLocalStreamsAPI = bi;
ee.shimRTCIceServerUrls = Si;
ee.shimRemoteStreamsAPI = Ci;
ee.shimTrackEventTransceiver = Pi;
var Vr = wi(J);
function zr(n) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (zr = function(d) {
    return d ? a : i;
  })(n);
}
function wi(n, i) {
  if (!i && n && n.__esModule)
    return n;
  if (n === null || he(n) !== "object" && typeof n != "function")
    return { default: n };
  var a = zr(i);
  if (a && a.has(n))
    return a.get(n);
  var u = {}, d = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in n)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(n, h)) {
      var v = d ? Object.getOwnPropertyDescriptor(n, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(u, h, v) : u[h] = n[h];
    }
  return u.default = n, a && a.set(n, u), u;
}
function he(n) {
  "@babel/helpers - typeof";
  return he = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, he(n);
}
function bi(n) {
  if (!(he(n) !== "object" || !n.RTCPeerConnection)) {
    if ("getLocalStreams" in n.RTCPeerConnection.prototype || (n.RTCPeerConnection.prototype.getLocalStreams = function() {
      return this._localStreams || (this._localStreams = []), this._localStreams;
    }), !("addStream" in n.RTCPeerConnection.prototype)) {
      var i = n.RTCPeerConnection.prototype.addTrack;
      n.RTCPeerConnection.prototype.addStream = function(u) {
        var d = this;
        this._localStreams || (this._localStreams = []), this._localStreams.includes(u) || this._localStreams.push(u), u.getAudioTracks().forEach(function(h) {
          return i.call(d, h, u);
        }), u.getVideoTracks().forEach(function(h) {
          return i.call(d, h, u);
        });
      }, n.RTCPeerConnection.prototype.addTrack = function(u) {
        for (var d = this, h = arguments.length, v = new Array(h > 1 ? h - 1 : 0), w = 1; w < h; w++)
          v[w - 1] = arguments[w];
        return v && v.forEach(function(C) {
          d._localStreams ? d._localStreams.includes(C) || d._localStreams.push(C) : d._localStreams = [C];
        }), i.apply(this, arguments);
      };
    }
    "removeStream" in n.RTCPeerConnection.prototype || (n.RTCPeerConnection.prototype.removeStream = function(u) {
      var d = this;
      this._localStreams || (this._localStreams = []);
      var h = this._localStreams.indexOf(u);
      if (h !== -1) {
        this._localStreams.splice(h, 1);
        var v = u.getTracks();
        this.getSenders().forEach(function(w) {
          v.includes(w.track) && d.removeTrack(w);
        });
      }
    });
  }
}
function Ci(n) {
  if (!(he(n) !== "object" || !n.RTCPeerConnection) && ("getRemoteStreams" in n.RTCPeerConnection.prototype || (n.RTCPeerConnection.prototype.getRemoteStreams = function() {
    return this._remoteStreams ? this._remoteStreams : [];
  }), !("onaddstream" in n.RTCPeerConnection.prototype))) {
    Object.defineProperty(n.RTCPeerConnection.prototype, "onaddstream", {
      get: function() {
        return this._onaddstream;
      },
      set: function(u) {
        var d = this;
        this._onaddstream && (this.removeEventListener("addstream", this._onaddstream), this.removeEventListener("track", this._onaddstreampoly)), this.addEventListener("addstream", this._onaddstream = u), this.addEventListener("track", this._onaddstreampoly = function(h) {
          h.streams.forEach(function(v) {
            if (d._remoteStreams || (d._remoteStreams = []), !d._remoteStreams.includes(v)) {
              d._remoteStreams.push(v);
              var w = new Event("addstream");
              w.stream = v, d.dispatchEvent(w);
            }
          });
        });
      }
    });
    var i = n.RTCPeerConnection.prototype.setRemoteDescription;
    n.RTCPeerConnection.prototype.setRemoteDescription = function() {
      var u = this;
      return this._onaddstreampoly || this.addEventListener("track", this._onaddstreampoly = function(d) {
        d.streams.forEach(function(h) {
          if (u._remoteStreams || (u._remoteStreams = []), !(u._remoteStreams.indexOf(h) >= 0)) {
            u._remoteStreams.push(h);
            var v = new Event("addstream");
            v.stream = h, u.dispatchEvent(v);
          }
        });
      }), i.apply(u, arguments);
    };
  }
}
function _i(n) {
  if (!(he(n) !== "object" || !n.RTCPeerConnection)) {
    var i = n.RTCPeerConnection.prototype, a = i.createOffer, u = i.createAnswer, d = i.setLocalDescription, h = i.setRemoteDescription, v = i.addIceCandidate;
    i.createOffer = function(y, _) {
      var S = arguments.length >= 2 ? arguments[2] : arguments[0], $ = a.apply(this, [S]);
      return _ ? ($.then(y, _), Promise.resolve()) : $;
    }, i.createAnswer = function(y, _) {
      var S = arguments.length >= 2 ? arguments[2] : arguments[0], $ = u.apply(this, [S]);
      return _ ? ($.then(y, _), Promise.resolve()) : $;
    };
    var w = function(y, _, S) {
      var $ = d.apply(this, [y]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    };
    i.setLocalDescription = w, w = function(y, _, S) {
      var $ = h.apply(this, [y]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    }, i.setRemoteDescription = w, w = function(y, _, S) {
      var $ = v.apply(this, [y]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    }, i.addIceCandidate = w;
  }
}
function $i(n) {
  var i = n && n.navigator;
  if (i.mediaDevices && i.mediaDevices.getUserMedia) {
    var a = i.mediaDevices, u = a.getUserMedia.bind(a);
    i.mediaDevices.getUserMedia = function(d) {
      return u(Br(d));
    };
  }
  !i.getUserMedia && i.mediaDevices && i.mediaDevices.getUserMedia && (i.getUserMedia = function(h, v, w) {
    i.mediaDevices.getUserMedia(h).then(v, w);
  }.bind(i));
}
function Br(n) {
  return n && n.video !== void 0 ? Object.assign({}, n, {
    video: Vr.compactObject(n.video)
  }) : n;
}
function Si(n) {
  if (n.RTCPeerConnection) {
    var i = n.RTCPeerConnection;
    n.RTCPeerConnection = function(u, d) {
      if (u && u.iceServers) {
        for (var h = [], v = 0; v < u.iceServers.length; v++) {
          var w = u.iceServers[v];
          w.urls === void 0 && w.url ? (Vr.deprecated("RTCIceServer.url", "RTCIceServer.urls"), w = JSON.parse(JSON.stringify(w)), w.urls = w.url, delete w.url, h.push(w)) : h.push(u.iceServers[v]);
        }
        u.iceServers = h;
      }
      return new i(u, d);
    }, n.RTCPeerConnection.prototype = i.prototype, "generateCertificate" in i && Object.defineProperty(n.RTCPeerConnection, "generateCertificate", {
      get: function() {
        return i.generateCertificate;
      }
    });
  }
}
function Pi(n) {
  he(n) === "object" && n.RTCTrackEvent && "receiver" in n.RTCTrackEvent.prototype && !("transceiver" in n.RTCTrackEvent.prototype) && Object.defineProperty(n.RTCTrackEvent.prototype, "transceiver", {
    get: function() {
      return {
        receiver: this.receiver
      };
    }
  });
}
function Ti(n) {
  var i = n.RTCPeerConnection.prototype.createOffer;
  n.RTCPeerConnection.prototype.createOffer = function(u) {
    if (u) {
      typeof u.offerToReceiveAudio < "u" && (u.offerToReceiveAudio = !!u.offerToReceiveAudio);
      var d = this.getTransceivers().find(function(v) {
        return v.receiver.track.kind === "audio";
      });
      u.offerToReceiveAudio === !1 && d ? d.direction === "sendrecv" ? d.setDirection ? d.setDirection("sendonly") : d.direction = "sendonly" : d.direction === "recvonly" && (d.setDirection ? d.setDirection("inactive") : d.direction = "inactive") : u.offerToReceiveAudio === !0 && !d && this.addTransceiver("audio", {
        direction: "recvonly"
      }), typeof u.offerToReceiveVideo < "u" && (u.offerToReceiveVideo = !!u.offerToReceiveVideo);
      var h = this.getTransceivers().find(function(v) {
        return v.receiver.track.kind === "video";
      });
      u.offerToReceiveVideo === !1 && h ? h.direction === "sendrecv" ? h.setDirection ? h.setDirection("sendonly") : h.direction = "sendonly" : h.direction === "recvonly" && (h.setDirection ? h.setDirection("inactive") : h.direction = "inactive") : u.offerToReceiveVideo === !0 && !h && this.addTransceiver("video", {
        direction: "recvonly"
      });
    }
    return i.apply(this, arguments);
  };
}
function Ei(n) {
  he(n) !== "object" || n.AudioContext || (n.AudioContext = n.webkitAudioContext);
}
const Oi = (n) => {
  let i = !1, a;
  return (...u) => (i || (a = n(u), i = !0), a);
};
function ie(n, i) {
  if (n === !1)
    throw new Error(i ?? "assertion failure");
}
const Mi = Oi(() => {
  const n = Ka(window);
  switch (n.browser) {
    case "chrome":
      li(window, n);
      break;
    case "firefox":
      hi(window, n);
      break;
    case "safari":
      gi(window, n);
      break;
    default:
      throw new Rr();
  }
});
let se = { isActive: !1 };
function Pt() {
  if (se.isActive) {
    se.videoEl.src = "", se.videoEl.srcObject = null, se.videoEl.load();
    for (const n of se.stream.getTracks())
      se.stream.removeTrack(n), n.stop();
    se = { isActive: !1 };
  }
}
async function Ai(n, { constraints: i, torch: a }) {
  var h, v;
  if (window.isSecureContext !== !0)
    throw new Na();
  if (((h = navigator == null ? void 0 : navigator.mediaDevices) == null ? void 0 : h.getUserMedia) === void 0)
    throw new Rr();
  Mi();
  const u = await navigator.mediaDevices.getUserMedia({
    audio: !1,
    video: i
  });
  if (n.srcObject !== void 0 ? n.srcObject = u : n.mozSrcObject !== void 0 ? n.mozSrcObject = u : window.URL.createObjectURL ? n.src = window.URL.createObjectURL(u) : window.webkitURL ? n.src = window.webkitURL.createObjectURL(u) : n.src = u.id, await Promise.race([
    xr(n, "loadeddata"),
    // On iOS devices in PWA mode, QrcodeStream works initially, but after
    // killing and restarting the PWA, all video elements fail to load camera 
    // streams and never emit the `loadeddata` event. Looks like this is 
    // related to a WebKit issue (see #298). No workarounds at the moment. 
    // To at least detect this situation, we throw an error if the event
    // has not been emitted after a 3 second timeout.
    gr(3e3).then(() => {
      throw new Ya();
    })
  ]), await gr(500), a) {
    const [w] = u.getVideoTracks();
    w.getCapabilities().torch ? w.applyConstraints({ advanced: [{ torch: !0 }] }) : console.warn("device does not support torch capability");
  }
  se = { videoEl: n, stream: u, isActive: !0 };
  const [d] = se.stream.getVideoTracks();
  return ((v = d == null ? void 0 : d.getCapabilities) == null ? void 0 : v.call(d)) ?? {};
}
const Di = { class: "qrcode-stream-wrapper" }, xi = { class: "qrcode-stream-overlay" }, Ri = /* @__PURE__ */ Et({
  __name: "QrcodeStream",
  props: {
    constraints: {
      type: Object,
      default() {
        return { facingMode: "environment" };
      }
    },
    formats: {
      type: Array,
      default: () => ["qr_code"]
    },
    paused: {
      type: Boolean,
      default: !1
    },
    torch: {
      type: Boolean,
      default: !1
    },
    track: {
      type: Function
    }
  },
  emits: ["detect", "camera-on", "camera-off", "error"],
  setup(n, { emit: i }) {
    const a = n, u = ke(), d = ke(), h = ke(), v = ke(!1), w = ke(!1);
    ma(() => {
      w.value = !0;
    }), ya(() => {
      Pt();
    });
    const C = dr(() => ({
      torch: a.torch,
      constraints: a.constraints,
      shouldStream: w.value && !a.paused
    }));
    St(C, async (A) => {
      const M = h.value;
      ie(M !== void 0, "cameraSettings watcher should never be triggered when component is not mounted. Thus video element should always be defined.");
      const T = u.value;
      ie(T !== void 0, "cameraSettings watcher should never be triggered when component is not mounted. Thus canvas should always be defined.");
      const j = T.getContext("2d");
      if (ie(j !== null, "if cavnas is defined, canvas 2d context should also be non-null"), A.shouldStream)
        try {
          const U = await Ai(M, A);
          w.value ? (v.value = !0, i("camera-on", U)) : Pt();
        } catch (U) {
          i("error", U);
        }
      else
        T.width = M.videoWidth, T.height = M.videoHeight, j.drawImage(M, 0, 0, M.videoWidth, M.videoHeight), Pt(), v.value = !1, i("camera-off");
    }, { deep: !0 });
    const { formats: y } = ga(a);
    St(y, (A) => {
      w.value && Ja(A);
    });
    const _ = dr(() => C.value.shouldStream && v.value);
    St(_, (A) => {
      if (A) {
        ie(u.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus pause frame canvas is defined"), S(u.value), ie(d.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus tracking canvas is defined"), S(d.value);
        const M = () => a.track === void 0 ? 500 : 40;
        ie(h.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus video element is defined"), Qa(h.value, {
          detectHandler: (T) => i("detect", T),
          formats: a.formats,
          locateHandler: $,
          minDelay: M()
        });
      }
    });
    const S = (A) => {
      const M = A.getContext("2d");
      ie(M !== null, "canvas 2d context should always be non-null"), M.clearRect(0, 0, A.width, A.height);
    }, $ = (A) => {
      const M = d.value;
      ie(M !== void 0, "onLocate handler should only be called when component is mounted. Thus tracking canvas is always defined.");
      const T = h.value;
      if (ie(T !== void 0, "onLocate handler should only be called when component is mounted. Thus video element is always defined."), A.length === 0 || a.track === void 0)
        S(M);
      else {
        const j = T.offsetWidth, U = T.offsetHeight, V = T.videoWidth, Z = T.videoHeight, ve = Math.max(j / V, U / Z), z = V * ve, H = Z * ve, Fe = z / V, Ie = H / Z, Ue = (j - z) / 2, je = (U - H) / 2, Ce = ({ x: ce, y: K }) => ({
          x: Math.floor(ce * Fe),
          y: Math.floor(K * Ie)
        }), Te = ({ x: ce, y: K }) => ({
          x: Math.floor(ce + Ue),
          y: Math.floor(K + je)
        }), We = A.map((ce) => {
          const { boundingBox: K, cornerPoints: st } = ce, { x: ct, y: ut } = Te(
            Ce({
              x: K.x,
              y: K.y
            })
          ), { x: te, y: me } = Ce({
            x: K.width,
            y: K.height
          });
          return {
            ...ce,
            cornerPoints: st.map((lt) => Te(Ce(lt))),
            boundingBox: DOMRectReadOnly.fromRect({ x: ct, y: ut, width: te, height: me })
          };
        });
        M.width = T.offsetWidth, M.height = T.offsetHeight;
        const it = M.getContext("2d");
        a.track(We, it);
      }
    };
    return (A, M) => (Ot(), Mt("div", Di, [
      Ke("video", {
        ref_key: "videoRef",
        ref: h,
        class: wa([{ "qrcode-stream-camera--hidden": !_.value }, "qrcode-stream-camera"]),
        autoplay: "",
        muted: "",
        playsinline: ""
      }, null, 2),
      ba(Ke("canvas", {
        ref_key: "pauseFrameRef",
        ref: u,
        class: "qrcode-stream-camera"
      }, null, 512), [
        [Ca, !_.value]
      ]),
      Ke("canvas", {
        ref_key: "trackingLayerRef",
        ref: d,
        class: "qrcode-stream-overlay"
      }, null, 512),
      Ke("div", xi, [
        Cr(A.$slots, "default", {}, void 0, !0)
      ])
    ]));
  }
});
const ki = (n, i) => {
  const a = n.__vccOpts || n;
  for (const [u, d] of i)
    a[u] = d;
  return a;
}, Fi = /* @__PURE__ */ ki(Ri, [["__scopeId", "data-v-dfa4038c"]]), Ii = /* @__PURE__ */ Et({
  __name: "QrcodeCapture",
  props: {
    formats: {
      type: Array,
      default: () => ["qr_code"]
    }
  },
  emits: ["detect"],
  setup(n, { emit: i }) {
    const a = n, u = (d) => {
      if (!(!(d.target instanceof HTMLInputElement) || !d.target.files))
        for (const h of Array.from(d.target.files))
          kr(h, a.formats).then((v) => {
            i("detect", v);
          });
    };
    return (d, h) => (Ot(), Mt("input", {
      onChange: u,
      type: "file",
      name: "image",
      accept: "image/*",
      capture: "environment",
      multiple: ""
    }, null, 32));
  }
}), Ui = ["onDrop"], ji = /* @__PURE__ */ Et({
  __name: "QrcodeDropZone",
  props: {
    formats: {
      type: Array,
      default: () => ["qr_code"]
    }
  },
  emits: ["detect", "dragover", "error"],
  setup(n, { emit: i }) {
    const a = n, u = async (v) => {
      try {
        const w = await v;
        i("detect", w);
      } catch (w) {
        i("error", w);
      }
    }, d = (v) => {
      i("dragover", v);
    }, h = ({ dataTransfer: v }) => {
      if (!v)
        return;
      d(!1);
      const w = [...Array.from(v.files)], C = v.getData("text/uri-list");
      w.forEach((y) => {
        u(kr(y));
      }), C !== "" && u(Za(C, a.formats));
    };
    return (v, w) => (Ot(), Mt("div", {
      onDrop: et(h, ["prevent", "stop"]),
      onDragenter: w[0] || (w[0] = et((C) => d(!0), ["prevent", "stop"])),
      onDragleave: w[1] || (w[1] = et((C) => d(!1), ["prevent", "stop"])),
      onDragover: w[2] || (w[2] = et(() => {
      }, ["prevent", "stop"]))
    }, [
      Cr(v.$slots, "default")
    ], 40, Ui));
  }
});
function Wi(n) {
  n.component("qrcode-stream", Fi), n.component("qrcode-capture", Ii), n.component("qrcode-drop-zone", ji);
}
const Li = { install: Wi };
let ot = null;
typeof window < "u" ? ot = window.Vue : typeof global < "u" && (ot = global.Vue);
ot && ot.use(Li);
export {
  Ii as QrcodeCapture,
  ji as QrcodeDropZone,
  Fi as QrcodeStream,
  Li as VueQrcodeReader,
  Wi as install,
  Vi as setZXingModuleOverrides
};
